{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require to Purchase Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}


{The Code has been annotated  as clearly as possible and hopefully is written in a manner
that will explain how the program was written and methods used with Delphi/Knife. The full
Code Version is Avialable with all Missing Functions enabled. I would suggest that the
code is also of use to the Visual Basic programer as the Majority of the code is very
similar in Structure. We also hope it will give the user an insight into how the
program was written and some of Delphis/Knifes abilities - AH}

program Bit;

{Source Code:-  This code is for the first Generation Demo.  It is intended
as a guide to the Creation of a Delphi Application based on Media Architects
ImageKnife 2.0 Control.  It is written from Scratch and should not be considered
to be a 'Polished Application'. Error Trapping is simple. The code Structure
represents a 'first attempt'. All Units or .Pas files have the 'U' prefix, and
if possible have the same Name as there associated form if they have one. Users
using the code will be able to organise Units/variables more efficiently. Below
is a list of All Units in the Project and their associated forms. Users also require
a Copy Of the KnifeControl Available from MediaArchitects to RUN the code in
the DESIGN environment}

uses

  Forms,
  Umaster in 'UMASTER.PAS' {FORM NAME 'MASTERFORM' -MAIN SCREEN},
  Ulaunch in 'ULAUNCH.PAS' {FORM NAME 'LAUNCH'},
  Udisplay in 'UDISPLAY.PAS' {FORM NAME 'DISPLAY' -CHILD DISPLAY },
  Uglobvar in 'UGLOBVAR.PAS', {GLOBAL VARIABLES}
  Upref in 'UPREF.PAS' {FORM NAME 'PREFERENCES' -PREFERENCES },
  Utools in 'UTOOLS.PAS' {FORM NAME 'TOOLS' - TOOL PALETTE},
  Uglobals in 'UGLOBALS.PAS', {GLOBAL SUBROUTINES}
  Ubackgnd in 'UBACKGND.PAS' {FORM NAME 'BACKGROUND' BACKGROUND TASKS},
  Uhist in 'UHIST.PAS' {FORM NAME 'HISTOGRAM' HISTOGRAM DISPLAY},
  Chartfx in 'CHARTFX.PAS', {HISTOGRAM CHART}
  Upalette in 'UPALETTE.PAS' {FORM NAME 'PALETTE' PALETTE DISPLAY},
  Ikdsp16 in 'IKDSP16.PAS', {KNIFE}
  Ikcon16 in 'IKCON16.PAS', {KNIFE - ANY UNIT THAT CALLS A KNIFE FUNCTION MUST HAVE THIS IN ITS USES CLAUSE}
  Uzoom in 'UZOOM.PAS' {FORM NAME 'ZOOM' - DYNAMIC ZOOM DISPLAY},
  Utext in 'UTEXT.PAS' {FORM NAME 'TEXTFORM' - TEXT INPUT FORM },
  Uresize in 'URESIZE.PAS' {FORM NAME 'RESIZE' - RESIZE FORM},
  Utint in 'UTINT.PAS' {FORM NAME 'TINT' - TINT FORM },
  Utune in 'UTUNE.PAS' {FORM NAME 'TUNER' - TUNER FORM},
  Uclone in 'UCLONE.PAS' {FORM NAME 'CLONE'},
  Ufunct in 'UFUNCT.PAS',{GLOBAL IMAGEKNIFE CALLS/FUNCTIONS}
  Uabout in 'UABOUT.PAS' {FORM NAME 'ABOUTBOX'},
  Uamount in 'UAMOUNT.PAS' {FORM NAME 'AMOUNT' - USER INPUTS};

{$R MYCURSOR.RES}

begin
  Application.Title := 'BIT';
  Application.CreateForm(TMASTERFORM, MASTERFORM);
  Application.CreateForm(TLAUNCH, LAUNCH);
  Application.CreateForm(TPREFERENCES, PREFERENCES);
  Application.CreateForm(TTOOLS, TOOLS);
  Application.CreateForm(TBACKGROUND, BACKGROUND);
  Application.CreateForm(THISTOGRAM, HISTOGRAM);
  Application.CreateForm(TPALETTE, PALETTE);
  Application.CreateForm(TZoom, Zoom);
  Application.CreateForm(TTextform, Textform);
  Application.CreateForm(TRESIZE, RESIZE);
  Application.CreateForm(TTint, Tint);
  Application.CreateForm(TTuner, Tuner);
  Application.CreateForm(TClone, Clone);
  Application.CreateForm(TAboutBox, AboutBox);
  Application.CreateForm(TAmount, Amount);
  Application.Run;
end.


{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 0131 337 8797
Fax UK + 0131 313 2002
Compuserve 100022,1047

This Program is intended to show the User the Basic Methods for Using ImageKnife Version 2.0
within the Delphi Programming environment.  It is intended for Guidelines Only.  You may use the
Source Code as part of a New Application.  You may not ReUse or Sell this program 'as-is' or
in any form without the written permission of Belmont Imaging. Users who wish a full working
Copy may Register the program with Belmont Imaging for a Small Fee - Refer to About Box.

Registered users will Receive a Full Version with no restrictions and Full Source Code is
available as a Cost option giving examples of the Majority of ImageKnife Functions and its
use within Delphi. A full Manual is also available for the Program.

Please note that this Demo Version is given 'as-is'.

We would urge users to register the software with Belmont Imaging at the above UK address
it is through registration that further enhancements can be made.

'ImageKnife'  is Copyright of Media Architects[MAI], Portland, OR 97223, USA Sales 503-639-2505
Belmont Imaging would like to thank Lyle Warnke of MAI for his assistance in writing this
Software. Users Must Comply with any restrictions placed on MAI VBX Controls.

Please refer to the 'About Box' when running the program for Registration fees. You
may also Read the String Contents of the Memo Item in the About form at Desgin Time.

This Demonstration Version is Distributed 'As Is' no warranty is given in any format.
Users use this Demonstration and Code at their own risk. Users Must Not Rename this Code
or Demonstration for the purposes of Selling it.

Registration Fees Valid to December 1995:-

Registration Fees [ U.S.A ]:-

1 Full Copy of Software $50 + PP Airmail $10 [inc .Wri Manual only]
Add on Options:-

A) Full Source Code  for use with Delphi $165 - Delphi .Pas Files 
Only. 
B) Fully Bound User Manual $35.

UK and Europe:-

1 Full Copy of Software 30 + PP Surface/Air 5 [inc .Wri Manual only]
Add on Options:-

A) Full Source Code for use with Delphi 100 - Delphi .Pas Files
only.
B) Fully Bound Manual 20

Source Code / Manual are only available as an additional Cost to the Full software Version.
They are not available on their own. Users will also require a Copy of ImageKnife 2.0
Custom Control available from Media Architects and Borlands Delphi to use the
code in the Delphi Design Environment.

Payment By Cheque [ U.S.A cheques are accepted in Dollars] or International Money Order
Made payable to 'Belmont Imaging' at time of Order. No Credit Cards. Orders must be made
in writing to Belmont Imaging at the above UK address. Cash is accepted we would advise
users who send Money to send it Registered - Insured. We cannot accept responsibility for
Cash lost in the Post.

[ Cheques in European Currencies other than Pounds Sterling are accepted with a 10% Banking
surcharge on the above UK pound Values.] See Readme.Wri for further details.

Direct 'Bank Transfer' Can be Made World Wide - Leave Compuserve Message or Fax for
Instructions - Software can be sent to the Users Compuserve ID on receipt of fee.

Please State Name, Full Address and Options Required.
( Please allow 28 Days for Delivery)

'ImageKnife' May be Obtained From Media Architects at above
address in the USA. 


Andrew and Gareth Hutchison.
July 1995}
