{********************************************}
{*                                          *}
{*  IKDSP16.PAS generated from IKDSP16.VBX  *}
{*                                          *}
{********************************************}

unit Ikdsp16;

interface

uses SysUtils, Classes, Graphics, Forms, Controls, VBXCtrl, BIVBX, Wintypes;

{ $DEFINE InitTPicBuf}
{^- Remove space to enable default init data -- See documentation. }

type
  TPicBufChangeEvent = procedure (Sender: TObject) of object;
  TPicBufPaintEvent = procedure (Sender: TObject) of object;
  TPicBufPanEvent = procedure (Sender: TObject) of object;
  TPicBufCallBackEvent = procedure (Sender: TObject; var Lines: Integer) of
    object;
  TPicBufPaletteEvent = procedure (Sender: TObject) of object;

  { TPicBuf }

  TPicBuf = class(TVBXControl)
  protected
    FOnChange: TPicBufChangeEvent;
    FOnPaint: TPicBufPaintEvent;
    FOnPan: TPicBufPanEvent;
    FOnCallBack: TPicBufCallBackEvent;
    FOnPalette: TPicBufPaletteEvent;
    { Event handler }
    procedure HandleVBXEvent(var Message: TWMVBXFireEvent); override;
    procedure DefineProperties(Filer: TFiler); override;


    { New Code for Palette updates *********************************************}
   function GetPalette: HPalette;override;
    {***************************************************************************}

  public
    constructor Create(AOwner: TComponent); override;

    property Index: TVBInteger index 1 read GetIntProp;
    property ColorDepth: TVBInteger index 29 read GetIntProp;
    property CopyDib: Boolean index 30 read GetBoolProp write SetBoolProp;
    property CopySelection: Boolean index 31 read GetBoolProp write
      SetBoolProp;
    property Contents: TVBEnum index 32 read GetEnumProp write SetEnumProp;
    property Control: TVBLongint index 33 read GetLongProp;
    property hDC: TVBInteger index 42 read GetIntProp;
      property hDib: TVBInteger index 43 read GetIntProp write SetIntProp;
    property hPalette: TVBInteger index 44 read GetIntProp write SetIntProp;
    property LoadPalette: TVBInteger index 52 read GetIntProp write
      SetIntProp;
    property PasteDib: Boolean index 57 read GetBoolProp write SetBoolProp;
    property PasteSelection: Boolean index 58 read GetBoolProp write
      SetBoolProp;
    property Picture: TVBPic index 59 read GetPictureProp write
      SetPictureProp;
    property PrinterhDC: TVBInteger index 64 read GetIntProp write SetIntProp;
    property SystemPalette: Boolean index 70 read GetBoolProp write
      SetBoolProp;
    property TextHigh: TVBInteger index 80 read GetIntProp;
    property TextWide: TVBInteger index 82 read GetIntProp;
    property Xresolution: TVBInteger index 85 read GetIntProp;
    property Yresolution: TVBInteger index 87 read GetIntProp;
  published
    property BackColor: TColor index 2 read GetColorProp write SetColorProp
      default -2147483633;
    property BorderStyle: TVBEnum index 3 read GetEnumProp write SetEnumProp
      default 1;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentFont;
    property ForeColor: TColor index 13 read GetColorProp write SetColorProp
      default -2147483640;
    property TabOrder;
    property TabStop;
    property Visible;
    property About: TVBString index 24 read GetStringProp {NoRT}write
      SetStringProp stored False;
    property AssignMode: TVBEnum index 25 read GetEnumProp write SetEnumProp;
    property AutoScale: Boolean index 26 read GetBoolProp write SetBoolProp;
    property AutoSize: Boolean index 27 read GetBoolProp write SetBoolProp;
    property CallbackLines: TVBInteger index 28 read GetIntProp write
      SetIntProp;
    property DrawArrows: TVBEnum index 34 read GetEnumProp write SetEnumProp;
    property DrawStyle: TVBEnum index 35 read GetEnumProp write SetEnumProp;
    property DrawWidth: TVBInteger index 36 read GetIntProp write SetIntProp;
    property FileName: TVBString index 37 read GetStringProp write
      SetStringProp;
    property FillColor: TColor index 38 read GetColorProp write SetColorProp;
    property FillStyle: TVBEnum index 39 read GetEnumProp write SetEnumProp;
    property FillTransparent: Boolean index 40 read GetBoolProp write
      SetBoolProp;
    property FontTransparent: Boolean index 41 read GetBoolProp write
      SetBoolProp;
    property ImageCompression: TVBInteger index 45 read GetIntProp write
      SetIntProp;
    property ImageFormat: TVBEnum index 46 read GetEnumProp write SetEnumProp;
    property ImageNumber: TVBInteger index 47 read GetIntProp write
      SetIntProp;
    property ScrollBarsLargeChange: TVBInteger index 48 read GetIntProp write
      SetIntProp;
    property LoadDllMode: TVBEnum index 49 read GetEnumProp {NoRT}write
      SetEnumProp;
    property LoadHeight: TVBInteger index 50 read GetIntProp write SetIntProp;
    property LoadOptions: TVBInteger index 51 read GetIntProp write
      SetIntProp;
    property LoadScale: TVBEnum index 53 read GetEnumProp write SetEnumProp;
    property LoadWidth: TVBInteger index 54 read GetIntProp write SetIntProp;
    property LZW: TVBString index 55 read GetStringProp {NoRT}write
      SetStringProp;
    property MousePointer: TVBInteger index 56 read GetIntProp write
      SetIntProp;
    property PrintHeight: TVBInteger index 60 read GetIntProp write
      SetIntProp;
    property PrintLeft: TVBInteger index 61 read GetIntProp write SetIntProp;
    property PrintTop: TVBInteger index 62 read GetIntProp write SetIntProp;
    property PrintWidth: TVBInteger index 63 read GetIntProp write SetIntProp;
    property ResizeMode: TVBEnum index 65 read GetEnumProp write SetEnumProp;
    property ScaleImage: TVBInteger index 66 read GetIntProp write SetIntProp;
    property ScaleScreen: TVBInteger index 67 read GetIntProp write
      SetIntProp;
    property ScreenPalette: Boolean index 68 read GetBoolProp write
      SetBoolProp;
    property ScrollBars: TVBEnum index 69 read GetEnumProp write SetEnumProp;
    property SelectHeight: TVBInteger index 71 read GetIntProp write
      SetIntProp;
    property SelectLeft: TVBInteger index 72 read GetIntProp write SetIntProp;
    property SelectTop: TVBInteger index 73 read GetIntProp write SetIntProp;
    property SelectWidth: TVBInteger index 74 read GetIntProp write
      SetIntProp;
    property ScrollBarsSmallChange: TVBInteger index 75 read GetIntProp write
      SetIntProp;
    property Text: TVBString index 76 read GetStringProp write SetStringProp;
    property TextAlignment: TVBEnum index 77 read GetEnumProp write
      SetEnumProp;
    property TextAutoSize: Boolean index 78 read GetBoolProp write
      SetBoolProp;
    property TextExtLeading: Boolean index 79 read GetBoolProp write
      SetBoolProp;
    property TextMultiLine: Boolean index 81 read GetBoolProp write
      SetBoolProp;
    property Version: TVBString index 83 read GetStringProp {NoRT}write
      SetStringProp stored False;
    property Xorigin: TVBInteger index 84 read GetIntProp write SetIntProp;
    property Yorigin: TVBInteger index 86 read GetIntProp write SetIntProp;
    property OnClick;
    property OnChange: TPicBufChangeEvent read FOnChange write FOnChange;
    property OnDblClick;
    property OnDragDrop;
    property OnEndDrag;
    property OnDragOver;
    property OnEnter;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnPaint: TPicBufPaintEvent read FOnPaint write FOnPaint;
    property OnPan: TPicBufPanEvent read FOnPan write FOnPan;
    property OnCallBack: TPicBufCallBackEvent read FOnCallBack write
      FOnCallBack;
    {property OnPalette: TPicBufPaletteEvent read FOnPalette write FOnPalette;}
  end;

procedure Register;

implementation
{ Default form data for TPicBuf }

{$IFDEF InitTPicBuf}

const
  TPicBufInitLen = 181;

procedure TPicBufInitData; near; assembler;
asm
	DB	$00,$06,$50,$69,$63,$42,$75,$66,$01,$00,$00,$02,$FF,$FF,$FF,$00
	DB	$03,$01,$05,$00,$06,$FF,$FF,$09,$00,$0D,$00,$00,$00,$00,$10,$12
	DB	$00,$00,$13,$00,$00,$14,$00,$16,$FF,$FF,$19,$00,$1A,$00,$00,$1B
	DB	$00,$00,$1C,$00,$00,$1E,$00,$00,$1F,$00,$00,$21,$50,$00,$1E,$59
	DB	$22,$00,$23,$00,$24,$01,$00,$25,$00,$26,$00,$00,$00,$00,$27,$01
	DB	$28,$00,$00,$29,$FF,$FF,$2D,$00,$00,$2E,$00,$2F,$00,$00,$30,$0A
	DB	$00,$31,$00,$32,$00,$00,$33,$00,$00,$35,$00,$36,$00,$00,$37,$00
	DB	$38,$01,$00,$39,$00,$00,$3A,$00,$00,$3C,$00,$00,$3D,$00,$00,$3E
	DB	$00,$00,$3F,$00,$00,$41,$00,$42,$01,$00,$43,$01,$00,$44,$00,$00
	DB	$45,$00,$47,$00,$00,$48,$00,$00,$49,$00,$00,$4A,$00,$00,$4B,$01
	DB	$00,$4C,$00,$4D,$00,$4E,$00,$00,$4F,$00,$00,$51,$00,$00,$54,$00
	DB	$00,$56,$00,$00,$FF
end;

{$ENDIF}

{ TPicBuf }

constructor TPicBuf.Create(AOwner: TComponent);
begin
  FVBXFile := StrNew('IKDSP16.VBX');
  FVBXClass := StrNew('PicBuf');
  SetBounds(0, 0, 80, 32);
  inherited Create(AOwner);
  ControlStyle := ControlStyle - [csCaptureMouse, csClickEvents] +
    [csAcceptsControls];
  TabStop := True;
  FVBXFlags := [vfLoadMessage];
  {$IFDEF InitTPicBuf}
  FHForm := VBXCreateFormFile(TPicBufInitLen, @TPicBufInitData);
  {$ENDIF}
end;

procedure TPicBuf.HandleVBXEvent(var Message: TWMVBXFireEvent);
begin
  case Message.VBXEvent^.EventIndex of
    0: DispatchNotifyEvent(OnClick);
    1: DispatchCustomEvent(FOnChange, Message, 1);
    2: DispatchNotifyEvent(OnDblClick);
    3: begin end; { VCL Handles OnDragDrop }
    4: begin end; { VCL Handles OnDragOver }
    5: begin end; { VCL Handles OnGotFocus }
    6: DispatchKeyEvent(OnKeyDown, Message);
    7: DispatchKeyPressedEvent(OnKeyPress, Message);
    8: DispatchKeyEvent(OnKeyUp, Message);
    9: begin end; { VCL Handles OnLostFocus }
    10: DispatchMouseEvent(OnMouseDown, Message);
    11: DispatchMouseMoveEvent(OnMouseMove, Message);
    12: DispatchMouseEvent(OnMouseUp, Message);
    13: DispatchCustomEvent(FOnPaint, Message, 13);
    14: DispatchCustomEvent(FOnPan, Message, 14);
    15: DispatchCustomEvent(FOnCallBack, Message, 15);
    16: DispatchCustomEvent(FOnPalette, Message, 16);
  end;
end;

procedure TPicBuf.DefineProperties(Filer: TFiler);
begin
  inherited DefineProperties(Filer);
  HandleProperty('CopyDib', Filer, 30);
  HandleProperty('CopySelection', Filer, 31);
  HandleProperty('Control', Filer, 33);
  HandleProperty('PasteDib', Filer, 57);
  HandleProperty('PasteSelection', Filer, 58);
  HandleProperty('Picture', Filer, 59);
end;

{New Code ***************************************************************************}
{At Present this 'Refreshes the Image' - force available palette onto it -
this may be another Images Palette however, it gives the nearest match
8 Bit images are forced to correct Palette on Load and Mouse Click on Image
This means all Images are Refreshed in a MDI application if Paint etc required
- disable this for faster applications but no auto updates}

function TPicBuf.GetPalette: HPalette;  {At Present Force a Refresh}
begin
With self do
Refresh;
{Result := Palette;}
end;

{ Designer registration }
procedure Register;
begin
  RegisterComponents('VBX', [
    TPicBuf]);
end;

end.
