{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}

unit Uamount; {Form Name 'Amount'}

{Form Amount Used to Input 1 to 10 Values for use with some Functions.  Each Speed
Button simply updates the Global Variable 'Amountset'.  Amountset is defined in Unit
Uglobvar and has a default value set here as well.}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons, Spin;

type {The 'TYPE' section is usually constructed by Delphi for the User}
  TAmount = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    value1: TSpeedButton;
    value2: TSpeedButton;
    value3: TSpeedButton;
    value4: TSpeedButton;
    value5: TSpeedButton;
    value6: TSpeedButton;
    value7: TSpeedButton;
    value8: TSpeedButton;
    value9: TSpeedButton;
    value10: TSpeedButton;
    Anglechange: TSpinButton;
    Angleset: TLabel;
    Bevel1: TBevel;
    Label1: TLabel;
    procedure value1Click(Sender: TObject);
    procedure value2Click(Sender: TObject);
    procedure value3Click(Sender: TObject);
    procedure value4Click(Sender: TObject);
    procedure value5Click(Sender: TObject);
    procedure value6Click(Sender: TObject);
    procedure value7Click(Sender: TObject);
    procedure value8Click(Sender: TObject);
    procedure value9Click(Sender: TObject);
    procedure value10Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AnglechangeDownClick(Sender: TObject);
    procedure AnglechangeUpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Amount: TAmount;

implementation

{Required Units}

Uses Uglobvar;

{$R *.DFM}

{All 'Speed Buttons' update AmountSet Global - then used in other functions}
procedure TAmount.value1Click(Sender: TObject);
begin
Amountset := 1;
end;

procedure TAmount.value2Click(Sender: TObject);
begin
Amountset := 2;
end;

procedure TAmount.value3Click(Sender: TObject);
begin
Amountset := 3;
end;

procedure TAmount.value4Click(Sender: TObject);
begin
Amountset := 4;
end;

procedure TAmount.value5Click(Sender: TObject);
begin
Amountset := 5;
end;

procedure TAmount.value6Click(Sender: TObject);
begin
Amountset := 6;
end;

procedure TAmount.value7Click(Sender: TObject);
begin
Amountset := 7;
end;

procedure TAmount.value8Click(Sender: TObject);
begin
Amountset := 8;
end;

procedure TAmount.value9Click(Sender: TObject);
begin
Amountset := 9;
end;

procedure TAmount.value10Click(Sender: TObject);
begin
Amountset := 10;
end;

{Update 'Rotate Angle' Caption. Label Name 'Angleset'.  By default when the form is loaded
set the Caption to the value contained in the Global 'RotationAngle' - defined in the Uglobvar
Module}
procedure TAmount.FormCreate(Sender: TObject);
begin
Angleset.Caption:= InttoStr(RotationAngle); {Convert Integer to String}
end;

{Use Spin Controls to add and Subtract RotationAngle - Down Click}
procedure TAmount.AnglechangeDownClick(Sender: TObject);
Var
Value: Integer;{Temp Varaible for Calculation}
begin
Value:= StrtoInt(Angleset.Caption); {Get current Value contained in Caption - Convert to Integer}
Value:= Value - 10; {Subtract 10 on every Click}
if Value < -360 then value := 0; {Trap Valid Range ie 0 to 360}
Angleset.Caption := Inttostr(Value);{Update Caption - convert format}
Rotationangle := Value; {Set Global to new Value}
end;

{Use Spin Controls to add and Subtract RotationAngle - Up Click}
procedure TAmount.AnglechangeUpClick(Sender: TObject);
Var
Value: Integer;
begin
Value:= StrtoInt(Angleset.Caption);
Value:= Value + 10;
if Value > +360 then value := 0;
Angleset.Caption := Inttostr(Value);
Rotationangle := Value;
end;

end.
