{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full  application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}

{'MasterForm' of Program - includes load an Image function}

unit Umaster;

{This Form is the 'Main Application Display'. The Form Name is 'MasterForm' it Should not be confuseded
with the call to 'Application.Mainform'. However, as far as this Project is concernded the
Application.Mainform is form 'Masterform'. Delphi allows you to select which form is the
'Mainform'. You must select 'Masterform' as the 'Mainform' - under project options.
You can read therefore read 'Mainform' as 'Masterform' and Vice-Versa. The Masterform is
a MDI Style Parent Form. It Creates its Child form on Demand from a Template form for the
Child called 'Display'. Display Is the Chils form and must be REMOVED from the 'Auto -Create'
list under Project Options. Please see notes in Unit Udisplay its expalins how to refer
to the Active MDI child. At Runtime The Child Forms or Displays Menu is Mergded with the
Main Application Displays Menu.  A few Functions are Called form the Application.Mainform [
Masterform ] so the function is always available to the user eg Load/Save Preference etc.
You Could Not put 'Load' for Example in the Childs [Display] menu as it would not be available
until the Image was Loaded - and you Can't Load it Because it is Not Visible until a
Image is Loaded - Catch 22!.}

interface
{Refer to all forms Required - See Implimentation Section as well. Don't worry about adding
all Units as Delphi Ignores functions within each unit that are not Used - IE we might
only use one Function in the 'SYSUTILS' unit - if that is the case then Delphi ignores
the Rest.}
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, ExtCtrls,ShellApi, VBXCtrl,
  StdCtrls, Buttons, Tabs,Ikdsp16, ikCon16,IniFiles;
 
type
  TMASTERFORM = class(TForm)
    MASTERFROM_MENU: TMainMenu;
    File1: TMenuItem;
    LoadFile1: TMenuItem;
    DeleteFile1: TMenuItem;
    N1: TMenuItem;
    STATUSBAR: TPanel;
    N12: TMenuItem;
    PrinterSetup1: TMenuItem;
    N15: TMenuItem;
    Exit1: TMenuItem;
    DiskControl: TOpenDialog;
    Utilities1: TMenuItem;
    DosShell1: TMenuItem;
    N2: TMenuItem;
    SetupPaths1: TMenuItem;
    User11: TMenuItem;
    User21: TMenuItem;
    User31: TMenuItem;
    User41: TMenuItem;
    User51: TMenuItem;
    User61: TMenuItem;
    N3: TMenuItem;
    Setup1: TMenuItem;
    Preferences1: TMenuItem;
    Window1: TMenuItem;
    Tile1: TMenuItem;
    Cascade1: TMenuItem;
    ArrangeIcons1: TMenuItem;
    MinimiseallChildren1: TMenuItem;
    N4: TMenuItem;
    ToolBar1: TMenuItem;
    SaveAs1: TMenuItem;
    SaveDiskcontrol: TSaveDialog;
    Bevel1: TBevel;
    Mouse: TLabel;
    Bevel2: TBevel;
    Properties: TLabel;
    Bevel3: TBevel;
    Memory: TLabel;
    Timer: TTimer;
    Redbuffer: TPanel;
    Greenbuffer: TPanel;
    Bluebuffer: TPanel;
    N5: TMenuItem;
    ClearallBuffers1: TMenuItem;
    QuickExit1: TMenuItem;
    TerminateProgramNoWarnings1: TMenuItem;
    About1: TMenuItem;
    AboutDemo1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure DosShell1Click(Sender: TObject);
    procedure SetupPaths1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure LoadFile1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure ArrangeIcons1Click(Sender: TObject);
    procedure MinimiseallChildren1Click(Sender: TObject);
    procedure Preferences1Click(Sender: TObject);
    procedure ToolBar1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure WndProc(Var Msg: TMessage);override; {Add this BY HAND for Drag/Drop}
    procedure FormDestroy(Sender: TObject);
    procedure ClearallBuffers1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TerminateProgramNoWarnings1Click(Sender: TObject);
    procedure AboutDemo1Click(Sender: TObject);
    private
    { Private declarations }

public
    { Public declarations }
    {Display Hints as Required}

procedure DisplayHint(Sender: Tobject); {Not Used}
{Code to enable Hint Display on Lower Caption or designated label}
end;

{Global Variables}
var
    MASTERFORM: TMASTERFORM; {Form Name}



implementation
{Refer to other Required forms}
uses Ulaunch,Udisplay,Uglobvar,UPref,Utools,UBackgnd,UAbout;

{Display form}
{$R *.DFM}

{Display Hint Sub for items without FlyOver Help}
Procedure TMASTERFORM.DisplayHint(Sender: Tobject);
begin
          {Use Status Bar Caption to display help if requested}
          {StatusBar.Caption:= Application.Hint; }
end;

{Set up Required Functions when form Created. Two Main things occur when the form is
created.  We enable DragDrop Events, this allows the user to Drag a file over the Master
form from the File Manger and drop it to load. The Second thing we must do is load our
own Cursor Resources. The Cursor is Created by using the Delphi Image editor. Create
a new Resource File .Res and add Your Cursors to it. Normally you would give the cursor
a Name - I have Left the Default Names as the Editor Created them. The .Res file you
created is 'loaded' in the Project 'Source' Unit - 'View' 'Source' to see this. You
must do this our a Compile error will occur. I hav e not used Knifes ability to load
a dll as we want the Cursors to be avialable outwith the Picbuf's}
procedure TMASTERFORM.FormCreate(Sender: TObject);
begin
try
{Load MyCursor file Resources}
       Screen.Cursors[1]:=LoadCursor(Hinstance,'CURSOR_1');{Normal Pick Cursor cross hair}
       Screen.Cursors[2]:=LoadCursor(Hinstance,'CURSOR_2');{Dynamic Zoom Cursor}
       Screen.Cursors[3]:=LoadCursor(Hinstance,'CURSOR_3');{Size Select Cursor}
       Screen.Cursors[4]:=LoadCursor(Hinstance,'CURSOR_4');{Wait BIT Cursor}
       Screen.Cursors[5]:=LoadCursor(Hinstance,'CURSOR_5');{Clone BIT Cursor}
{Acccept file drags}
       DragAcceptFiles(Handle, True);
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
end;
end;

{Destroy as required}
procedure TMASTERFORM.FormDestroy(Sender: TObject);
begin
DragAcceptfiles(Handle, False); {Kill Drag Accept}
end;

{Load a Valid File From a Drop Event from say file Manager. This procedure is added to handle
windows messages passed to the application - we want to use WM_DROPFILES only. When the
application receives this message load an Image}
procedure TMasterform.WndProc(Var Msg: TMessage);
var Num: Word; {Used to process drop events}
Buff: Array[0..80] of Char;
N:Word;
NewDisplay : TDisplay;
begin
try
if (Msg.Msg = WM_DropFiles) then begin{Is this a Drag Event}
Msg.Result := 0;
Num := DragQueryFile(Msg.wParam, $FFFF, NIL, 0);
For N := 0 to pred(num) do {This Allows Multiple files to be handled}
begin
DragQueryFile(Msg.wParam, n, buff, pred(SizeOf(buff)));
     Screen.Cursor:= 4;  {Show bit Wait Cursor}
     NewDisplay := TDisplay.Create(Self);{Create New Display}
     NewDisplay.Parent :=Self;
{Set various modes depending on Preferences Selected stored in INI file/preference form - See Below}
     NewDisplay.Picbuf1.Assignmode := Preferences.Displayassignmode.Itemindex;

Case Preferences.Displayautoscale.Itemindex of
     0: NewDisplay.Picbuf1.Autoscale := False;
     1: NewDisplay.Picbuf1.Autoscale := True;
end;

Case Preferences.DisplayAutosize.Itemindex of
      0: NewDisplay.Picbuf1.Autosize := False;
      1: NewDisplay.Picbuf1.Autosize := True;
end;

      NewDisplay.Picbuf1.Resizemode := Preferences.Displayresizemode.Itemindex;

      {Fif loads only set up options}
      NewDisplay.Picbuf1.LoadOptions := Preferences.Fifoptions.Itemindex;
      NewDisplay.Picbuf1.Loadscale := Preferences.Fifscale.Itemindex;
      NewDisplay.Picbuf1.Loadheight := StrtoInt(Preferences.Fifheight.Text);
      NewDisplay.Picbuf1.Loadwidth := StrtoInt(Preferences.Fifwidth.Text);

      {Enable Scroll bars if Requested - force sizing to false}
If Preferences.Scrollbars.Checked then
      begin
      NewDisplay.Picbuf1.AutoScale := False; {Must be False}
      NewDisplay.Picbuf1.Autosize := False;  {Must be False}
      NewDisplay.Picbuf1.Scrollbars := 3;
      end;

      {Load Image}
      NewDisplay.Picbuf1.Filename:= buff;
      ikload (NewDisplay.Picbuf1.ctl);
      NewDisplay.Caption := buff;{Set Caption to Current File Name}

      {Update Palette}
      If Newdisplay.Picbuf1.Contents  = 1 then {Is there a Valid Image?}
      begin
      If Newdisplay.Picbuf1.Colordepth <= 8 then {Has a Palette}
      IksetScreenpal(NewDisplay.Picbuf1.ctl); {Update}
      end;

      {Close Non Valid displays}
      If Newdisplay.Picbuf1.Contents  <> 1 then Newdisplay.Close;
      Screen.Cursor:= crDefault;  {Show Default Cursor}
      end;

Dragfinish(Msg.wParam);
end
else
inherited WndProc(Msg);
except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Corrupt File Type -'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
   Screen.Cursor:= crDefault;  {Show Default Cursor}
   end;
end;





{Launch a Dos Shell form menu item click - File name derived from launch form. Unit
Ulaunch Holds this Form. Shell Execute trys to run the .EXE selected. Note you
must pass a Pchar type name to this function, hence appending Chr$ 0 - #0 to the names}
procedure TMASTERFORM.DosShell1Click(Sender: TObject);
var Command,Params,WorkDir: String;
    Result:integer;
begin
try
{Use values of Text boxes on Launch Form - @ creates a Pchar type}
     Command := Launch.ProgramName.Text + #0;{Append Chr$0 = Pchar}
     Params := Launch.Parameters.Text + #0;
     WorkDir := Launch.WorkingDirectory.text + #0;
{Execute Program - Display Errorbox if Could not. the  @ is required - turns it into the Pointer}
     Result:= ShellExecute(Handle,'open',@Command[1],@Params[1],@Workdir[1],sw_show);
  if Result < 32 then {This means an Error occurded}
     MessageDlg('Could not Execute Requested file - ' + Launch.ProgramName.Text
     + '. Error Code - '+ IntToStr(Result),mtError,[mbOK],0);
  except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
  end;

{Display Launch Dialog Form - Form 'Launch' - as a Modal Dialog Box}
procedure TMASTERFORM.SetupPaths1Click(Sender: TObject);
begin
     LAUNCH.ShowModal; {Modal Means the User Must Clos it Before Going On}
end;

{Terminate Program but with close prompts. Start Closing Application - the Close
Query of Every Child is Called}
procedure TMASTERFORM.Exit1Click(Sender: TObject);
begin
Masterform.Close;{ If we Close the 'Masterform' all connected forms are closed}
end;

{Open a File and Create a Display Window. Whenever a File is Loaded we must create
a form for that file or Image. At Design time we Design this form and designate it
as a 'Child Form' - you add Menus/Picbufs to it. This means the Masterform can then Load it as
a Child.  We can Create as many as we wish at runtime with no extra code.

Note that the Child form Must be removed from the Auto Create option under Project Options.
In this Project the Child form is called 'Display' and its Unit is 'UDisplay'. You will notice
that we refer to the Display in Many Cases as 'TDISPLAY', this is because the form
is a Standard Delphi 'TObject' so in some case we refer to this object standard object
or Base Class:- 'Display' is based on TDISPLAY. As far as we are concerned this TDISPLAY
is created for us when we name the Child Form as DISPLAY at DESIGN TIME.

MDI APPLICATIONS: One of the Main Problems with MDI applications is referencing the
Active Child. At Runtime we Can Create Several 'Child DISPLAY' forms. They all have the Same
controls on them so we must be able to access the one we Require - Normally the Active One.


V Basic Users are Used to the format Form1.Activeform.Picbuf1 etc, this
however is not sufficient in Delphi. There is a Similar Method - Application.Mainform.
ActiveMDIChild. This allows us to control the Child Form but NOT THE PICBUF CONTROLS ON IT.
In order to get access to the Childs Picbuf Control we have to refer to the Display's base
class. See Notes on 'MainForm' and 'TDisplay' Above.

With Application.Mainform.ActiveMDIchild as TDisplay do
Begin
Picbuf1.Backcolor := RGB(0,0,0);
end;

The Statement above then allows us to access all controls on it. The Application.Mainform
in our Case is the Mainform called 'Masterform' or Unit Umaster. The ActiveMDICHILD is the
Child or DISPLAY form created at run time that has the Focus. We Reference its base Class
TDISPLAY - this then allows us to access the controls we placed on it at Design time. Remember
that in effect this is the same as refering to the DISPLAY form Directly. In the Above Example
we are setting the Backcolor of the Picbuf1 to a RGB value. This occurs for any Display
that is Made Active.  To Create a Display at Runtime the following Code is used

**** Button Click Event ****
Var
NewDisplay : TDisplay *** allocate Name for New Display ***
Begin
NewDisplay := TDisplay.Create(Self); *** Create New Display and show it ***
NewDisplay.Parent := Self; *** Makes Sure that when Display is Closed it Kills all connected controls
NewDisplay.Picbuf1.Filename:= DiskControl.Filename; *** Dialog Disk Control to get file to load
ikload (NewDisplay.Picbuf1.ctl); *** Load the file NOTE THE .CTL QUALIFICATION - MUST USE THIS
NewDisplay.Caption := DiskControl.Filename; *** Update Caption
end;

The Above would create a new Copy of Display, the form you created at Design time called
NewDisplay. We can then Reference the Picbuf1 control we placed on it. After it is loaded
it becomes a child. Keep calling the above will keep adding new Copies of Display. Remember
Display Must be allocated as a Child form & take note of Close Event for that child form
- See Udisplay Unit Form Close Event}


{Notes On Below. The Preference Screen Contains all option that can be set by the user
when an image is First Loaded.See Prference Unit - Upref. Remember to Create the child
before you make any references to It.}
procedure TMASTERFORM.LoadFile1Click(Sender: TObject);
var
     NewDisplay : TDisplay; {Name Child to be Created. Reference 'Display' Forms Base Class}
begin
try
     DiskControl.FilterIndex:= Lastfilter; {Set Dialog Filter Index to Last Value}
     If DiskControl.Execute then {Display a Load Dialogue Box. If OK select then Load Image}
Begin
     Screen.Cursor:= 4;  {Show bit Wait Cursor. This loads our Cursor}
     NewDisplay := TDisplay.Create(Self);{Create New Display based on our Design time Form 'Display'}
     NewDisplay.Parent := Self;
{Set various modes depending on Preferences Selected stored in INI file/preference form}
     NewDisplay.Picbuf1.Assignmode := Preferences.Displayassignmode.Itemindex;

Case Preferences.Displayautoscale.Itemindex of
     0: NewDisplay.Picbuf1.Autoscale := False;
     1: NewDisplay.Picbuf1.Autoscale := True;
end;

Case Preferences.DisplayAutosize.Itemindex of
      0: NewDisplay.Picbuf1.Autosize := False;
      1: NewDisplay.Picbuf1.Autosize := True;
end;

{Enable Scroll bars if Requested - force sizing to false}
If Preferences.Scrollbars.Checked then
      begin
      NewDisplay.Picbuf1.AutoScale := False; {Must be False}
      NewDisplay.Picbuf1.Autosize := False;  {Must be False}
      NewDisplay.Picbuf1.Scrollbars := 3;
      end;

      NewDisplay.Picbuf1.Resizemode := Preferences.Displayresizemode.Itemindex;
      {Fif loads only set up options}
      NewDisplay.Picbuf1.LoadOptions := Preferences.Fifoptions.Itemindex;
      NewDisplay.Picbuf1.Loadscale := Preferences.Fifscale.Itemindex;
      NewDisplay.Picbuf1.Loadheight := StrtoInt(Preferences.Fifheight.Text);
      NewDisplay.Picbuf1.Loadwidth := StrtoInt(Preferences.Fifwidth.Text);

      {Load Image}
      NewDisplay.Picbuf1.Filename:= DiskControl.Filename;
      ikload (NewDisplay.Picbuf1.ctl);
      NewDisplay.Caption := DiskControl.Filename;{Set Caption to Current File Name}

      {Update Palette for 8 Bit Images only}
      If Newdisplay.Picbuf1.Contents  = 1 then {Is there a Valid Image?}
      begin
      If Newdisplay.Picbuf1.Colordepth <= 8 then {Has a Palette}
      IksetScreenpal(NewDisplay.Picbuf1.ctl); {Update}
      end;

      {Close Non Valid displays}
      If Newdisplay.Picbuf1.Contents  <> 1 then
      begin
      Newdisplay.Close; {Close form}
      Screen.Cursor:= crDefault;  {Show Default Cursor}
      Exit; {Abort Sub}
      end;

end;{End if Execute}

{Set Lastfilter value to selected file extension (1 if no match). We Use the Delphi
'Pos' function to see if the appropriate extension was in the filename. If it was
we can set the 'Lastfilter' index to that file extension filter IndexPosition. Each
time we then Call the Load Dialogue Box we can set the default Filter to the last
filter type loaded. Lastfilter is Global and Defined in the Uglobvar Unit}
      Lastfilter :=1; {*.* is index = 1}
if Pos('TIF',DiskControl.Filename) > 0 then
      Lastfilter :=2;
if Pos('TGA',DiskControl.Filename) > 0 then
      Lastfilter :=3;
if Pos('BMP',DiskControl.Filename) > 0 then
      Lastfilter :=4;
if Pos('DIB',DiskControl.Filename) > 0 then
      Lastfilter :=5;
if Pos('PCX',DiskControl.Filename) > 0 then
      Lastfilter :=6;
if Pos('JPG',DiskControl.Filename) > 0 then
      Lastfilter :=7;
if Pos('FIF',DiskControl.Filename) > 0 then
      Lastfilter :=8;
      Screen.Cursor:= crDefault;  {Show Default Cursor - always restore default cursor after
      the function is completed. We use the BIT 'Wait' Cursor to indicated the system
      is working.}
     except
  begin
  MessageDlg('A System Error has occured - Load Error - Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  Screen.Cursor:= crDefault;  {Show Default Cursor - in case error has occurded}
  end;
end;
end;

{Tile Child Windows - Use Standard Calls}
procedure TMASTERFORM.Tile1Click(Sender: TObject);
begin
      Masterform.Tile;
end;

{Cascade Child Windows}
procedure TMASTERFORM.Cascade1Click(Sender: TObject);
begin
      Masterform.Cascade;
end;

{Arrange Icons}
procedure TMASTERFORM.ArrangeIcons1Click(Sender: TObject);
begin
      Masterform.ArrangeIcons;
end;

{Minimise all Child Windows. MDICHILDCOUNT is a Property of a Parent Form in this
case Masterform. It contains the Number of Child forms active.}
procedure TMASTERFORM.MinimiseallChildren1Click(Sender: TObject);
Var
      I: integer;{Temp}
begin
try
for I := 0 to MDIchildcount - 1   do
      MDIchildren[i].WindowState := wsMinimized;
for I := 0 to MDIchildcount - 1   do  {Second call closes Last Child}
      MDIchildren[i].WindowState := wsMinimized;
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
end;
end;


{Show Preference Screen. Show Preference form Name 'Preferences' Unit Upref}
procedure TMASTERFORM.Preferences1Click(Sender: TObject);
begin
      Preferences.Showmodal;
end;


{Show Tool Bar - Check Menu Item as Required - Swap Between States Visible or Not}
procedure TMASTERFORM.ToolBar1Click(Sender: TObject);
begin
If Tools.Visible = False then {If form was not Visible Make it Visible}
  Begin
   Tools.Show;
   ToolBar1.Checked := True;
  end
else
  begin
  Tools.Visible := False;  {If form was  Visible then Hide It}
  ToolBar1.Checked:= false;
  end;
end;

{Save an Image to Disk - MDI Active Child. We use the Reference method desribed above}
procedure TMASTERFORM.SaveAs1Click(Sender: TObject);
begin
try
If Application.Mainform.MDIChildcount = 0 then Exit;{Abort with no Image present}
  With Application.Mainform.ActiveMDIChild as TDisplay do {Set focus to Active MDI Child}
   begin {Start Loop refering to Active Child - we need then only refer to the Design time names}
    If SaveDiskControl.Execute then {Display Save Dialogue Box. If OK selected then Save Image}
     Begin
      Screen.Cursor := 4; {Wit Cursor}
      if Pos('JPG',SaveDiskControl.Filename) > 0 then {Check to see if File to be JPEG}
      Picbuf1.ImageCompression:= StrtoInt(Preferences.Jpeglabel.Caption) {If a Jpeg File Set Compression}
       else {Normal Saves}
       Picbuf1.ImageCompression := 0;{Set default to compression all formats}
       Picbuf1.Filename := SaveDiskcontrol.Filename; {Set Filename}
       ikStore(Picbuf1.ctl); {Save Image}
       Screen.Cursor := crDefault;  {Normal Cursor}
     end;
   end;
except
  begin
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  Screen.Cursor := crDefault; {In Case of error restore Default}
  end;
end;
end;

{Update Memory Caption 3 sec Updates. This event is from a timer Control. We check Memory
avialable and wether the Background Buffers are empty. The slower the update the
less demand on Windows Resources}
procedure TMASTERFORM.TimerTimer(Sender: TObject);
begin
try
Masterform.Memory.Caption:= FormatFloat('#######',MemAvail DIV 1024)+' KB, SR ' +
IntToStr(GetFreeSystemResources(GFSR_SYSTEMRESOURCES)) + ' % Free'; {API CAll}
{Check on Status of Background RGB Channel Buffers - Color panels as Required}
if Background.Redbuffer.Contents <> 1 then Redbuffer.Color := ClYellow
 else
  Redbuffer.Color := clRed;
if Background.Greenbuffer.Contents <> 1 then Greenbuffer.Color := ClYellow
 else
  Greenbuffer.Color := clGreen;
if Background.Bluebuffer.Contents <> 1 then Bluebuffer.Color := ClYellow
 else
  Bluebuffer.Color := clBlue;
 except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
 end;
end;

{Clear all Buffers - Empty All Buffers on Demand.Hint we could have used the Format
'with Background Do' - this means we would not have to refer each time to
the backgorund form - more efficient }
procedure TMASTERFORM.ClearallBuffers1Click(Sender: TObject);
begin
try
{Try Alternate :-  With BackGround Do}
ikClear(Background.Redbuffer.Ctl); {If we used alternate you could drop 'Background.' Call}
ikClear(Background.Greenbuffer.Ctl);
ikClear(Background.Bluebuffer.Ctl);
ikClear(Background.Scratch.Ctl);
ikClear(Background.MasterPalette.Ctl);
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;


{Confirm Exit. This is called if the application is closed- Prompt User to Confirm}
procedure TMASTERFORM.FormCloseQuery(Sender: TObject;
var CanClose: Boolean);
var
  ButtonSelected: Word;
begin
try
  ButtonSelected := MessageDlg('Please Confirm Exit. All unsaved Data will be lost.', mtInformation,
    [mbyes, mbNo], 0);
  if ButtonSelected = mryes then {If Confirmed allow exit}
    CanClose := True
  else
    CanClose := False; {Do not allow close to occur}
  except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Stop Program without calling any 'can close events' ie no warnings. This causes the
program to terminate without Close Queries}
procedure TMASTERFORM.TerminateProgramNoWarnings1Click(Sender: TObject);
begin
Halt;
end;


{Show About Application Form - Name 'Aboutbox' Unit Uabout}
procedure TMASTERFORM.AboutDemo1Click(Sender: TObject);
begin
Aboutbox.Showmodal;
end;

end.
