{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full  application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}

unit Upalette;

{Uses Form Name 'Palette' Unit Upalette. By Means of a DrawGrid Component we can Display an Images
Palette. Note That the Palette Form MUST BE UPDATED ON AND PAINT EVENT. This is Because
the Method used to Paint the Color squares is not handled Automatically by the Control -
Indeed after the Palette is Calculated for a Image - Called form Unit Utools - we
force the Palette form to Refesh causing a Paint Event to Occur thus Updating it. CreatePalette
Sub in the Uglobals unit Calculates the Palette. The Palette is then held in an Array which
is then Used in the Paint Event of the Palette form. The Palette Array is global and defined
in the Uglobvar Unit}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids,Ikcon16, ExtCtrls;

type
  TPALETTE = class(TForm)
    DrawGrid1: TDrawGrid;
    Colorcontrol: TColorDialog;
    Bevel1: TBevel;
    procedure DrawGrid1DrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure DrawGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PALETTE: TPALETTE; {Form Name}

implementation
Uses Uglobals,Umaster,Udisplay,Uglobvar;
{$R *.DFM}

{Use Paint calls to fill Grid Locations - occurs on any paint event. The Basic Idea
is to Obtain the Rectangular Area of Each Grid Cell in the DrawGrid Control and Paint
it the Color Depending on the Cells Location Realative to the Palette position. For
Example The Grid Cell in Row 0 Coloum 1 or Upper left Cell is GridCell 0 this can be Used
for Palette Location 0 Cell 2 is Palette 2 etc etc up to cell 255 palette 255. Note we must
calculate the GridCells value to equal a range of 0 to 255 to reflect palette locations.
For Row 0 nothing is required. therafter we must to a simply calculation. The Draw Cell
event Occurs for every cell when is requires painted and from the Paramters Delphi passes
we can calculate its Location, hence its palette loaction and hence the color to paint it.
PalDATA is a GLOBAL variable containg the Palette data from 0 to 255 - it was calculated
in the Uglobals Unit.

The Formula to get the Location is Row * 16 + Col:- this gives us a range up to 255 Note
Row '0' does not Require the Formula.[Row can be 0 to 15 and Col 1 to 16]}

Procedure TPALETTE.DrawGrid1DrawCell(Sender: TObject; Col, Row: Longint;
Rect: TRect; State: TGridDrawState);{Note Row and Col is passed as a parameter as is RECT}
var
Rectangle: Trect;  {Standard T Rect Function}
Location: Integer; {Calculate Grid Vis Palette Location: - Location then holds Cells Location}
 begin
 try
    If Row = 0 then { First Row is correct 0 to 15 palette position}
    Location := Col {Set Location to Row Value - this is the 'Location' of the Cell requesting the paint event}
    else
     Begin {All other rows cells must be converted to get 'palette location' 16 * 16 grid}
     Location := (Row * 16) + Col; {Correction factor to get cell position to reflect 0 to 255}
     end; {Set Rectangle to RECT passed by function - RECT holds the AREA of the CELL requireing Painting}
      Rectangle := Rect; {Get Rectangular area of Cell being repainted}
      {Get Palette Color at Location off Cell - Give the Canvas Brush this Color}
      Palette.Drawgrid1.Canvas.Brush.Color:= Paldata[Location];{Set of cell to color from array data}
      {Fllogd the Calling Cell with its Palettes locations Color}
      Palette.Drawgrid1.Canvas.Fillrect(Rectangle); {Paint cell correct color}
  except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;


{Find out mouse down cell - convert to Palette location and activate color dialog box. Use Formula
above to get Palette location of the Cell we clicked the Mouse On. We can then Display
a Color Dialog Box and Use the Color Selected to Replace the Palette locations scolor
with the new Selected Color - not finished in Demo Version}
procedure TPALETTE.DrawGrid1MouseDown(Sender: TObject;
 Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
 Column, Row: Longint;
 Location: Integer; {Holds Location based on mouse down loaction}
 Newcolor: LongInt;{Holds color selected from dialog box}
 begin
  Drawgrid1.MouseToCell(X, Y, Column, Row);

   If Row = 0 then {First Row is correct 0 to 15 [16*16 grid]}
    Location := Column
    else
    Location := (Row * 16) + Column; {Correction factor to all other rows}
    If Colorcontrol.Execute then {Activate color dialog box}
    begin
    Application.NormalizeTopMosts;{Allows Dialogs to appear over a topmost window}
    Newcolor:= Palette.Colorcontrol.Color; {Store Selected Color}
    Application.RestoreTopMosts; {Reset topmosts}
    Colorpalettereplace(NewColor, Location); {Pass color and Palette location to be changed
    to Globals unit sub}
  end;
 end;

end.
