{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}


unit Utools;{'Tools' form}

{This form is Central to the Program.  It forms the Tool palette.  It is a
'Stayontop' form. All Buttons are Speed Buttons, 1 Tab Control -Tabs- and 1 NotePad control -Pad-}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Tabs, StdCtrls, Buttons, Menus, ikCon16, VBXCtrl,Clipbrd;

{All Buttons on are Speed Buttons}
type
  TTOOLS = class(TForm)
    Tabs: TTabSet; {Tab Control}
    Pad: TNotebook;{Pad Control - Holds several pages with the Icon Buttons on them}
    Loadanimage_tool: TSpeedButton; {All following Buttons Are Speed Type}
    Saveanimage_tool: TSpeedButton; {All Control Button on the Tool palette have suffix '_tool'}
    Zoomin_tool: TSpeedButton;
    Zoomout_tool: TSpeedButton;
    Dynamiczoom_tool: TSpeedButton;
    Printimage_tool: TSpeedButton;
    Imagezoomsetup_tool: TSpeedButton;
    Imageprintsetup_tool: TSpeedButton;
    Brightnesscontrast_tool: TSpeedButton;
    Gamma_tool: TSpeedButton;
    Tintrgb_tool: TSpeedButton;
    Tune_tool: TSpeedButton;
    Convertto4_tool: TSpeedButton;
    Convertto8_tool: TSpeedButton;
    Convertto24_tool: TSpeedButton;
    Reducecolorsto_tool: TSpeedButton;
    Sharpen_tool: TSpeedButton;
    Soften_tool: TSpeedButton;
    Blur_tool: TSpeedButton;
    Matrix3x3_tool: TSpeedButton;
    Matrix5x5_tool: TSpeedButton;
    Rotate_tool: TSpeedButton;
    Mirror_tool: TSpeedButton;
    Extractedge_tool: TSpeedButton;
    Histogram_tool: TSpeedButton;
    Rchannel_tool: TSpeedButton;
    Gchannel_tool: TSpeedButton;
    Bchannel_tool: TSpeedButton;
    Palette_tool: TSpeedButton;
    Resize_tool: TSpeedButton;
    Merge_tool: TSpeedButton;
    Mask_tool: TSpeedButton;
    Definearea_tool: TSpeedButton;
    Toolpalette_popup: TPopupMenu;
    RemoveBorder1: TMenuItem;
    ForceToScreenCentre1: TMenuItem;
    Showtextoptions: TSpeedButton;
    Textselection: TSpeedButton;
    Tool_Clone: TSpeedButton;
    Copyfull: TSpeedButton;
    Copyselection: TSpeedButton;
    Pastefull: TSpeedButton;
    Pasteselection: TSpeedButton;
    Clearclipboard: TSpeedButton;
    SelectCliparea: TSpeedButton;
    LoadPalette_Tool: TSpeedButton;
    MapChildtoMaster_Tool: TSpeedButton;
    Imagetopalette_tool: TSpeedButton;
    procedure TabsClick(Sender: TObject); {Most Procedures are 'Click' events}
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Loadanimage_toolClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure RemoveBorder1Click(Sender: TObject);
    procedure ForceToScreenCentre1Click(Sender: TObject);
    procedure Histogram_toolClick(Sender: TObject);
    procedure Rchannel_toolClick(Sender: TObject);
    procedure Gchannel_toolClick(Sender: TObject);
    procedure Bchannel_toolClick(Sender: TObject);
    procedure Palette_toolClick(Sender: TObject);
    procedure Saveanimage_toolClick(Sender: TObject);
    procedure Zoomin_toolClick(Sender: TObject);
    procedure Zoomout_toolClick(Sender: TObject);
    procedure Dynamiczoom_toolClick(Sender: TObject);
    procedure Imagezoomsetup_toolClick(Sender: TObject);
    procedure ShowtextoptionsClick(Sender: TObject);
    procedure TextselectionClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Merge_toolClick(Sender: TObject);
    procedure Resize_toolClick(Sender: TObject);
    procedure Tintrgb_toolClick(Sender: TObject);
    procedure Tune_toolClick(Sender: TObject);
    procedure Definearea_toolClick(Sender: TObject);
    procedure Tool_CloneClick(Sender: TObject);
    procedure Convertto24_toolClick(Sender: TObject);
    procedure Convertto8_toolClick(Sender: TObject);
    procedure Convertto4_toolClick(Sender: TObject);
    procedure CopyfullClick(Sender: TObject);
    procedure CopyselectionClick(Sender: TObject);
    procedure PastefullClick(Sender: TObject);
    procedure PasteselectionClick(Sender: TObject);
    procedure ClearclipboardClick(Sender: TObject);
    procedure SelectClipareaClick(Sender: TObject);
    procedure Sharpen_toolClick(Sender: TObject);
    procedure Soften_toolClick(Sender: TObject);
    procedure Extractedge_toolClick(Sender: TObject);
    procedure Rotate_toolClick(Sender: TObject);
    procedure Blur_toolClick(Sender: TObject);
    procedure LoadPalette_ToolClick(Sender: TObject);
    procedure MapChildtoMaster_ToolClick(Sender: TObject);
    procedure Imagetopalette_toolClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TOOLS: TTOOLS;

implementation
{The following Units could be Required by the Tool Palette}
Uses Umaster,Udisplay,Uglobals,Upalette,Uzoom,Uglobvar,UPref,Utext,Ubackgnd,Utint,Utune,Uclone,Ufunct;

{$R *.DFM}

{Whenever the User Clicks a Tab on the palette, Turn to the Correct 'notebook' page - Tab control is
called 'Tabs' and notebook control is called 'Pad'}
procedure TTOOLS.TabsClick(Sender: TObject);
 begin
  {Use Index Properties to 'Sync' Controls}
  Pad.PageIndex := Tabs.Tabindex;
 end;

{Any code required when Closing Tool Form.  When the palette is closed remove the Menu
Check mark from the MainScreen-Menu. 'Masterform' is the name of the MainScreen[Unit-UMaster]}
procedure TTOOLS.FormClose(Sender: TObject; var Action: TCloseAction);
  begin
  Masterform.ToolBar1.Checked := False;{Remove menu Check Mark from Correct Item}
end;

{Load file uses indirectly Masterform Load file Event}
procedure TTOOLS.Loadanimage_toolClick(Sender: TObject);
 begin
 try {Try is setting up errortrap - protects all code called from this point on 'down the line'}
 {This Procedure calls a 'sub' in Uglobals Unit - that sub calls the Masterform load}
 Callmasterformload;
 except {Display a Message Box if ANY error occurs}
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
 end;

{When the Tool Form is 'Activated' make sure Tabs/Pages are in Sync}
procedure TTOOLS.FormActivate(Sender: TObject);
begin
{Make Sure Tabs and Palette Pages are in Sync}
Tabs.Tabindex := Pad.Pageindex;
end;

{Remove Border from Tool Palette use API calls to get Height of Forms Border
and Caption Height.  We require to do this or else when the Caption Bar is removed
the form is Moved Up the Screen by the Height of the Caption Bar. Mainly
so a User can Place the Palette at the Bottom of the Screen - remove the Caption
bar and have the form remain at the Bottom of the Screen}
procedure TTOOLS.RemoveBorder1Click(Sender: TObject);
Var
MenuHeight: Integer; {Temp Storage for Menu height or Caption in this case}
BorderHeight: Integer; {Temp Storage}
begin
try
  MenuHeight := Getsystemmetrics(4);{Width of Forms Caption Bar is metrics 4}
  BorderHeight:= Getsystemmetrics(8) * 2;{Width of Forms Border is metrics 8 (Twice - Top/Bottom)}
  MenuHeight := MenuHeight + BorderHeight; {Get Total Height of Removeded Items}
{Remove/Reinstate 'Tool Palette' forms Border / Check Uncheck as Required}
  If Tools.BorderStyle = bsDialog then {If Form was a dialog type}
   Begin
    Tools.Borderstyle := bsNone;{Remove Border}
    RemoveBorder1.Checked := True;{Check Menu Item}
    Tools.Height := Tools.Height - MenuHeight; {Alter form height to allow for no Caption}
    Tools.Top := Tools.Top + MenuHeight;{Alter Position to allow for Caption removal}
   end
    else {If form was not a Dialog style then we have to Add Caption Back}
     Begin
     Tools.BorderStyle := BsDialog; {Reset Form Style to Default}
     RemoveBorder1.Checked := False; {Remove Check}
     Tools.Height := Tools.Height + MenuHeight;{Add Height back to Form}
     Tools.Top := Tools.Top - MenuHeight;{Restore Position to allow for new Height}
     end;
     except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Force Tool Palette to Screen Center}
procedure TTOOLS.ForceToScreenCentre1Click(Sender: TObject);
begin
{Force Form to Screen Centre on Demmand - Set property 'Position'}
Tools.Position := poScreenCenter;
end;

{Normally all functions apply to the Active MDI Child - see Below}
{Call Histogram Subroutines depending on color depths.  8 Bit Images use one sub
24 Bit Images use another. 24 Bit Images are Split RGB.}
procedure TTOOLS.Histogram_toolClick(Sender: TObject);
begin
try {Error Trap}
{Check to see if a Child form exists. If not Exit Sub.}
If Masterform.MDIChildcount = 0 then
Exit;
{We Must Make a Reference to the Base Class the Child window was Based on. Each
Image is Displayed as a Child to the Masterform. Masterform is the Name of the
Parent Form - Unit Umaster. Each Child form is based on the 'Display' form - Unit
Udisplay. In order to refer to the Picbufs on the Child forms we must refer to this Display form.
To do this we Refer to the Displays base class TDisplay.  [Note: 'Display' is a Child Form.]
You must remove this form from the AutoCreate Function under Project Options.
Each time a Image is Loaded we Create a 'Copy' or Instance of this Display Form.

Note the line Application.Mainform.ActiveMDIchild as Tdisplay. This lets us access any control
on the Active Child. 'Application' is a Delphi Function as is 'Mainform'. Mainform is set
to the Parent form of all Childs in this case 'Masterform' - we reference 'Masterform' by
using the 'Mainform' reference. ActiveMDIchild gives access to the Child that is in 'focus'.
This Means that all Functions/Menus are Created only once at Design time. Control Names
will not change etc.  Any function or call normally uses this code}
  with Application.Mainform.Activemdichild as TDisplay do {Set up Reference to 'Child Display'}
   Case Picbuf1.Colordepth of {Check Picbuf1 Colordepth using Case - call Histogram accordingly}
   0..9:Createhistogram8bit;  {Its a 8 Bit Image}
   10..24:Createhistogram24bit; {Its a 24 Bit Image}
   end;
   except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Call procedure Createredchannel to create a Red Channel image. Only Works with 24 Bit Images}
procedure TTOOLS.Rchannel_toolClick(Sender: TObject);
begin
try
{Check to see if a Child form exists for the Parent form - abort sub if not}
If Masterform.MDIChildcount = 0 then
Exit;
{Check to see if image is 24 Bit - abort sub if not}
with Application.Mainform.Activemdichild as TDisplay do {Refer to  Active Child}
 If Picbuf1.Colordepth < 24 then
  begin
  MessageDlg('Image must be 24 Bit for this function. Convert if required.', mtInformation,
  [mbOk], 0);
  Exit; {Leave Sub}
  end;
{Call sub routine}
Createredchannel; {Call 'UGlobals' Unit sub. No Parameters are passed}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{ Create a Green Channel Image}
procedure TTOOLS.Gchannel_toolClick(Sender: TObject);
begin
try
{Check to see if a Child form exists}
 If Masterform.MDIChildcount = 0 then
 Exit;
{Check to see if image is 24 Bit - abort sub if not}
with Application.Mainform.Activemdichild as TDisplay do
 If Picbuf1.Colordepth < 24 then
  begin
   MessageDlg('Image must be 24 Bit for this function. Convert if required.', mtInformation,
   [mbOk], 0);
   Exit;
end;
{Call sub routine}
Creategreenchannel; {UGlobals Unit Sub}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Create a Blue Channel Image}
procedure TTOOLS.Bchannel_toolClick(Sender: TObject);
begin
try
{Check to see if a Child form exists}
If Masterform.MDIChildcount = 0 then
Exit;
{Check to see if image is 24 Bit - abort sub if not}
with Application.Mainform.Activemdichild as TDisplay do
 If Picbuf1.Colordepth < 24 then
  begin
  MessageDlg('Image must be 24 Bit for this function. Convert if required.', mtInformation,
  [mbOk], 0);
  exit;
  end;
 {Call sub routine}
 Createbluechannel; {Uglobals Unit}
 except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
 end;

{Create A Palette Display - if the Active Image is 8 Bit. See Palette sub in Uglobals
for Details.}
procedure TTOOLS.Palette_toolClick(Sender: TObject);
begin {Abort for non valid images ie no palette or no image}
 try
 If Masterform.MdiChildcount = 0 then exit; {Is there a Child Active}
  With Application.Mainform.Activemdichild as TDisplay do
   If Picbuf1.Colordepth > 8 then {Is the Child 8 Bit - if not Warn then Exit sub}
   begin
   MessageDlg('Image must be 8 Bit or Less and have a Palette for this function. Convert if required.', mtInformation,
   [mbOk], 0);
   Exit;
   end;
  {Call Palette Sub Routine}
  CreatePalette; {Uglobals Unit Sub}
  Palette.DrawGrid1.Refresh;{Force 'Palette Form' to redraw and therefore update}
  except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
 end;

{Call 'Masterform' 'Save As' Sub to save Image. We Call this sub so we don't have to
keep duplicating functions}
procedure TTOOLS.Saveanimage_toolClick(Sender: TObject);
begin
Masterform.SaveAs1Click(Sender);{We Must pass Sender as a Parameter}
end;

{Enlarge Image - Zoom in - Autosize must be False.
Autosize is a property of the Picbuf Control}
procedure TTOOLS.Zoomin_toolClick(Sender: TObject);
begin
try
 If Application.Mainform.MDIChildCount = 0 then Exit; {Reference active Display}
  With Application.Mainform.ActiveMDIchild as Tdisplay do
   Begin
   Picbuf1.Scalescreen := (Picbuf1.Scalescreen + 1); {Simply Add 1 to Scalescreen with every click}
   end;
   except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Reduce Image - Zoom Out - Autosize must be false}
procedure TTOOLS.Zoomout_toolClick(Sender: TObject);
begin
try
 If Application.Mainform.MDIChildCount = 0 then Exit;
  With Application.Mainform.ActiveMDIchild as Tdisplay do
   Begin
   Picbuf1.ScaleImage := (Picbuf1.ScaleImage + 1); {Add 1 to Scale Image with  every Click}
   end;
   except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Enable / Disable Dynamic Zoom set Mouseoption flag.  MouseOption Flag is used in the
Child Display unit - UDisplay form Name Display.  This flag is set to the Function Required
when the Mouse Is Used with a Child Display.  In the Case of Dynamic Zoom Set MouseOption to
'Z'.  A Mouseoption of 'Q' is used to Indicate no Selected Function. Dynamic Zoom is Used
to Determine if the Option is already selected or Not. The user could test to see if Mouseoption
was already set to Z or Not as an alternate.  Both Flags are Global -UGobvar}
procedure TTOOLS.Dynamiczoom_toolClick(Sender: TObject);
begin
try
If Application.Mainform.Mdichildcount = 0 then Exit;
 If Dynamiczoom = false then  {If Not Selected then Select}
  begin
   Dynamiczoom := True; {Flag}
   Mouseoption := 'Z'; {Set Tool to Dynamic Zoom - Refer to Display Mouse Move Event}
   Zoom.Show;{Display Zoom Form}
  end
  else  {If Already Selected then De-select}
  begin
   Dynamiczoom := False;
   Mouseoption := 'Q';{Turn off Mouse Flagg}
   IkClear(Zoom.Picbuf1.Ctl);{Clear Zoom Memory - Saves Resources}
   Zoom.Hide;{Hide form - Do not Kill it totally- this would cause a fatal error}
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Display Preference form}
procedure TTOOLS.Imagezoomsetup_toolClick(Sender: TObject);
begin
try
Preferences.Show;{Show the Preference Screen - it is a Modal Form}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Display Text Setup Options by Calling Sub}
procedure TTOOLS.ShowtextoptionsClick(Sender: TObject);
begin
try
Inserttext;{Call Sun in UGlobals to Add Text to Image}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Enable / Disable Selection Area method. Similar to Dynamic Zoom method above. Set MouseOption
Flag to Select Area Function. }
procedure TTOOLS.TextselectionClick(Sender: TObject);
begin
If Application.Mainform.MDIchildcount = 0 then Exit;
  If Mouseoption = 'S' then {If already set for selection change to nothing}
     Mouseoption := 'Q' {No Function Selected}
     else
     Mouseoption := 'S';{If not Set then Set option for mouse to S = Select area}
  end;

{Show Tool Bar by Default. When the Computer Creates the Tool form Display it by Default.
Properties of the form make it Central and Always on Top}
procedure TTOOLS.FormCreate(Sender: TObject);
begin
Tools.Show; {By Default show Tool form}
end;

{Call Merge Sub. This Calls the Sub in Unit DGlobals to Combine Images. If any of the
Buffers are empty of Images Abort Sub. Images are assigned to Background buffers by
means of a 'Popup' menu called by a RightClick with the Mouse to the Image Area.Righ Click
methos always by default calls a PopUp if a PopUp Menu is available.}
procedure TTOOLS.Merge_toolClick(Sender: TObject);
begin
try
{Check for Valid Buffers ie 24 Bit + A valid Dib}
With Background do  {Reference Background Form. We then need only to refer to the Control Names}
begin
If RedBuffer.Contents <> 1 then Exit;  {Only Result 1 means a Image/Palette Exists}
If GreenBuffer.Contents <> 1 then Exit;
If BlueBuffer.Contents <> 1 then Exit;
{Check to See if Image in the Buffer is 24Bit again abort sub / Prompt user if not}
If RedBuffer.Colordepth <> 24 then
   begin {Use Begin - End block to tie Code together}
    MessageDlg('Red Channel Image must be 24 Bit for this function. Convert if required.', mtInformation,
    [mbOk], 0);
    Exit;
   end;
If GreenBuffer.Colordepth <> 24 then
   begin
    MessageDlg('Green Channel Image must be 24 Bit for this function. Convert if required.', mtInformation,
    [mbOk], 0);
    Exit;
   end;
If BlueBuffer.Colordepth <> 24 then
   begin
    MessageDlg('Blue Channel Image must be 24 Bit for this function. Convert if required.', mtInformation,
    [mbOk], 0);
    Exit;
   end;
end;
{Call Global Sub to Merge 24 Bit RGB Channels.At this stage we have checked for valid Images}
Combine24bit;{See Unit Uglobals}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Call Sub to Resize Image. Do a Quick Check to see if a Child Window is Active.}
procedure TTOOLS.Resize_toolClick(Sender: TObject);
begin
try
If Application.Mainform.MdichildCount = 0 then Exit;{If no Image Abort}
ResizeImage; {Call Global - See unit Uglobals}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Call RGB Tint routine - if a Image exists on masterform load it. We also check for a Valid 24 Bit
Image.  If a Image is Active on the Screen try and pass it to the Tint Buffer. The Tint
Function always works with the Actve Child Image. The Tint Form Preview Buffer acts only
as a Preview - A Child Image Must be active for it to Function.}
procedure TTOOLS.Tintrgb_toolClick(Sender: TObject);
begin
try
If Application.Mainform.Mdichildcount = 0 then  {Is there a Child Active?}
Tint.Show{Show Dialog if no Child is Active - do not try to pass it an Image.}
else
begin  {If a Child Exists reference it and Check Image Contained in It}
With Application.Mainform.ActiveMDIchild as Tdisplay do
begin
If Picbuf1.ColorDepth < 24 then {Child Image Must Be 24 Bit}
begin
MessageDlg('Image Must Be 24 Bit Convert If Required. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
Tint.Show; { Tell User that the Child Image must be 24 Bit - do not pass image to tint}
Exit;
end;
{If the Child Image is Visable and 24 Bit then Copy it to the Tint form}
ikassign(Tint.Picbuf1.ctl,0,Picbuf1.ctl,0); {Copy Image Accross}
Tint.Show;{Show Dialog}
end;
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Call Rgb Tune Routine - if a Image exists on masterform load it. This Is similar to the Tint
Function Above.  Again pass a Image to it if A valid child Image Exists.}
procedure TTOOLS.Tune_toolClick(Sender: TObject);
begin
try
If Application.Mainform.Mdichildcount = 0 then
Tuner.Show{Show Dialog - do not passs a Image}
else
begin
With Application.Mainform.ActiveMDIchild as Tdisplay do
begin
If Picbuf1.ColorDepth < 24 then {Image Must Be 24 Bit}
begin
MessageDlg('Image Must Be 24 Bit Convert If Required. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
Tuner.Show;{Show Dialog - do not passs a Image}
Exit;
end;
ikassign(Tuner.Picbuf1.ctl,0,Picbuf1.ctl,0); {Copy Image Accross}
Tuner.Show;{Show Dialog - Pass a Image}
end;
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Enable Selection Function. Again like above set MouseOption to 'S' for Selection}
procedure TTOOLS.Definearea_toolClick(Sender: TObject);
begin
If Application.Mainform.MDIchildcount = 0 then Exit;
If Mouseoption = 'S' then {If already set for selection change to nothing}
   Mouseoption := 'Q'
else
   Mouseoption := 'S';{Set option for mouse to S = Select area}
end;

{Show Clone Display and Set Mouseoption to 'C' for Clone. Used In Child Mouse Move Event}
{If clone form already Visible leave form Visible turn off function}
{No Auto Load of Image. Toggle Function On/Off enable/disable Cursors}
procedure TTOOLS.Tool_CloneClick(Sender: TObject);
begin
If Mouseoption = 'C' then {If already enabled then Disable}
Begin
Mouseoption := 'Q';
Clone.Picbuf1.Cursor:= 1;{Enable Clone Cursor}
{Note: The Main Child  Picbuf Display Know to Display the Correct Cursor according to Function}
end
else
begin
MouseOption := 'C'; {Set Mouseoption to 'C' which means clone}
Clone.Picbuf1.Cursor:= 5;{Enable Clone Cursor}
Clone.Show;{Show form}
end;
end;

{Convert Active Image to 24 Bit warn user if already 24 Bit.  Some functions are not
implimented from the UGlobals Unit.  User Should place all Functions in a Common Unit.
This Application does nto at present do this for all functions}
procedure TTOOLS.Convertto24_toolClick(Sender: TObject);
begin
try
if Application.Mainform.Mdichildcount = 0 then Exit;{Is there a Image}
With Application.Mainform.ActiveMDIchild as TDisplay do {Reference Display}
begin
If Picbuf1.ColorDepth = 24 then {If already 24 Bit abort after telling user}
begin {Requires a Begin - End to allow multple lines of Code}
MessageDlg('The Active Image is already 24 Bit. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
Exit; {Exit Sub}
end;
IkincreaseColors(Picbuf1.Ctl, 24); {Call Function for Valid Image}
end;
except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Convert Image to 8 Bit use select case to effect correct conversion. Users may want
to add user set options for the possibel options for the Reduce function, Dither,Bleed etc.
Use a Case Check to Check for Current Bit depth and to respond accordingly. Use Reduce
colors to obtain reductions in color depths}
procedure TTOOLS.Convertto8_toolClick(Sender: TObject);
 begin
 try
 if Application.Mainform.Mdichildcount = 0 then Exit;{Is there a Child?}
  With Application.Mainform.ActiveMDIchild as TDisplay do {Reference Display}
   begin
    case Picbuf1.Colordepth of {Get Color Depth at present}
    1: IkincreaseColors(Picbuf1.Ctl, 8); {Call Function 1 to 8 Bit}
    4: IkincreaseColors(Picbuf1.Ctl, 8); {Call Function 4 to 8 Bit}
    8: MessageDlg('The Active Image is Already 8 Bit. Choose OK to Continue.' , mtInformation,
    [mbOk], 0); {Image already 8 - no Change}
    24: IkReducecolors(Picbuf1.Ctl,256,-1,-1,-1);{Set all options to true -1 then reduce to 8 Bit}
    end;
   end;
 except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Convert to 4 Bit, Use Case to check Current and Increasde/Decrease as requireded}
procedure TTOOLS.Convertto4_toolClick(Sender: TObject);
begin
try
if Application.Mainform.Mdichildcount = 0 then Exit; {Is there a Image}
 With Application.Mainform.ActiveMDIchild as TDisplay do {Reference Display}
  begin
   case Picbuf1.Colordepth of {Get Color Depth at present}
   1: IkincreaseColors(Picbuf1.Ctl, 4); {Call Function  1 to 4 Bit}
   4:  MessageDlg('The Active Image is Already 4 Bit. Choose OK to Continue.' , mtInformation,
   [mbOk], 0);
   8:  IkReducecolors(Picbuf1.Ctl,16,-1,-1,-1);{Set all options to true -1, 8 to 4 Bit}
   24: IkReducecolors(Picbuf1.Ctl,16,-1,-1,-1);{Set all options to true -1, 24 to 4 Bit}
  end;
 end;
 except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;


{Copy Full Image to Clipboard - All Clipboard function use Knifes abilities. Always Check for
Valid Child and Valid Picture Content before doing the Copy/Paste function}
procedure TTOOLS.CopyfullClick(Sender: TObject);
begin
try
If Application.Mainform.MDIchildcount = 0 then exit;  {Is there a Child}
With Application.Mainform.ActiveMdichild as TDisplay do {Reference Display}
   begin
    If Picbuf1.Contents <> 1 then Exit; {If No image is Present Abort Sub}
    Picbuf1.CopyDib := True;{Full Picture Area copy to Clipboard}
    end;
except {Note The E.Message holds the error message connected with the raised exception}
    on E: EVBXError do {Possible Errors are Source/Destination having different Bit Depths}
    MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
    + E.Message, mtInformation,
     [mbOk], 0);
      else
      MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
     end;
end;

{Copy Selection To Clipboard - see above}
procedure TTOOLS.CopyselectionClick(Sender: TObject);
begin
    try
    If Application.Mainform.Mdichildcount = 0 then Exit;
    With Application.Mainform.ActiveMDIchild as Tdisplay do
    begin
    If Picbuf1.Contents <> 1 then Exit;
    Picbuf1.CopySelection := True;
    end;
     except
      on E: EVBXError do
      MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
      + E.Message, mtInformation,
      [mbOk], 0);
      else
     MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
    end;
 end;

{Paste Full Image from Clipboard - see above}
procedure TTOOLS.PastefullClick(Sender: TObject);
begin
   try
   If Application.Mainform.Mdichildcount = 0 then exit; {Make Sure Image exists}
    With Application.Mainform.ActiveMDIchild as TDisplay Do {Reference Active Child}
     begin
      If Picbuf1.Contents <> 1 then Exit;
      Picbuf1.PasteDib := True;{If a Image Exists Copy to It}
      end;
   except
    on E: EVBXError do
    MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
    + E.Message, mtInformation,
     [mbOk], 0);
     else
     MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
     end;
   end;

{Paste To selection area - As Above}
 procedure TTOOLS.PasteselectionClick(Sender: TObject);
 begin
  try
   If Application.Mainform.Mdichildcount = 0 then exit;
    With Application.Mainform.ActiveMDIchild as TDisplay do
     begin
     If Picbuf1.Contents <> 1 then Exit;
     Picbuf1.PasteSelection := True;
     end;
    except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
 end;

{Empty Clipboard}
procedure TTOOLS.ClearclipboardClick(Sender: TObject);
begin
try
Clipboard.Clear;{Use Delphi Call to empty Clipboard}
except
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Set Selection Function - only if Image Exists.  Some Palette tabs have repeated functions,
this stops the User having to swap between tabs to get to a function. This function again sets the
MouseOption Global to S - toggles it On/Off}
procedure TTOOLS.SelectClipareaClick(Sender: TObject);
begin
If Application.Mainform.MDIchildcount = 0 then Exit;
  If Mouseoption = 'S' then {If already set for selection change to nothing}
     Mouseoption := 'Q'{No Function}
     else
     Mouseoption := 'S';{Set option for mouse to S = Select area}
  end;

{Sharpen an Image - Call sub in Funct Unit:-
Placing the error trap here means an additional trap is not required in the
Sub-Routine - As Errortraps protects anything called from the Statement that had
the Trap in It. Normally the User should handle all exceptions with specific
catchers. For this Demo the .Else section in the trap covers any exception.}
procedure TTOOLS.Sharpen_toolClick(Sender: TObject);
begin
try
if Application.Mainform.MDIchildcount = 0 then exit; {Only Execute if image present}
Sharpen;{Sub Name as it appears in Uglobal Unit}
except
  on E: EVBXError do {VBX error ie Knife}
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Soften Image}
procedure TTOOLS.Soften_toolClick(Sender: TObject);
begin
try
if Application.Mainform.MDIchildcount = 0 then exit; {Only Execute if image present}
Soften;{Sub Name in Uglobal Unit}
except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Edge Extract}
procedure TTOOLS.Extractedge_toolClick(Sender: TObject);
begin
try
if Application.Mainform.MDIchildcount = 0 then exit; {Only Execute if image present}
Edgeextract; {Sub Name in Uglobal Unit}
except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Rotate Image}
procedure TTOOLS.Rotate_toolClick(Sender: TObject);
begin
try
if Application.Mainform.MDIchildcount = 0 then exit; {Only Execute if image present}
Rotate; {Sub Name in Uglobal Unit}
except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Blur Image}
procedure TTOOLS.Blur_toolClick(Sender: TObject);
begin
try
if Application.Mainform.MDIchildcount = 0 then exit; {Only Execute if image present}
Blur;{Sub Name in Uglobal Unit}
except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;
{Error Trapping is Basic in this application. The trap responds with a Coverall Message.
It is better practice not to do this.  You will find traps duplicated throughout the application.
However, this is done to try and prevent system errors with a 'first' draft code}



{8 Bit Graphics Card User Note:-  Any Function that Uses a Copy to 8 Bit Image the
Source and Destination should be mapped to the same palette to stop bizarre
color Shifting - not applicable to 24 Bit images or 8 Bit that have the Same Palette.
Options in Demo Use an Image in the 'Background form', that can be loaded either from
disk or Transfer from Active Image. The Actvie Image Can then Be Mapped to this}


{Load AN IMAGE AND place it in the Background.Masterpalette buffer - use it to then
map other Images to it}
procedure TTOOLS.LoadPalette_ToolClick(Sender: TObject);
begin
try
 Masterform.DiskControl.FilterIndex:= Lastfilter; {Set Dialog Filter Index to Last Value}
 If Masterform.DiskControl.Execute then {Display a Load Dialogue Box. If OK select then Load Image}
 Begin
  Screen.Cursor:= 4;  {Show bit Wait Cursor. This loads our Cursor}
  Background.MasterPalette.Filename:= Masterform.DiskControl.Filename;
  ikload (Background.Masterpalette.ctl);
  {Kill Non Valid displays}
 If Background.MasterPalette.Contents  <> 1 then
   begin
    ikClear(Background.MasterPalette.Ctl);
    Screen.Cursor:= crDefault;  {Show Default Cursor}
    Exit; {Abort Sub}
   end;
 end;{End if Execute}
      Screen.Cursor:= crDefault;  {Show Default Cursor - always restore default cursor after
      the function is completed. We use the BIT 'Wait' Cursor to indicated the system
      is working.}
 except
  begin
  MessageDlg('A System Error has occured - Load Error - Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  Screen.Cursor:= crDefault;  {Show Default Cursor - in case error has occurded}
  end;
end;
end;

{Map the Active Child to the Image in the Background MasterPalette buffer -
try and allow for non Valid options}
procedure TTOOLS.MapChildtoMaster_ToolClick(Sender: TObject);
begin
try
If Application.Mainform.MDIChildcount = 0 then Exit;{Non Valid Image}
If Background.MasterPalette.Contents <> 1 then {Non Valid Image}
Begin
MessageDlg('Master "Palette" Image is Not Valid or Empty.' , mtInformation,
[mbOk], 0);
Exit;{Non Valid Image}
end;
If Background.MasterPalette.ColorDepth > 8 then {Non Valid Image}
Begin
MessageDlg('Master "Palette" Image does Not Have a Palette - Please Load 8 Bit Image/Palette' , mtInformation,
[mbOk], 0);
Exit;{Abort}
end;
With Application.Mainform.ActiveMDIchild as Tdisplay do {Refer to MAin Display}
begin
If Picbuf1.Contents <> 1 then Exit;{Non Valid Image}
If Picbuf1.ColorDepth > 8 then {Image Not 8 Bit or Less}
Begin
MessageDlg('Main Display Image is 24 Bit and Cannot be Mapped to a Palette.' , mtInformation,
[mbOk], 0);
Exit; {Abort}
end;
ikDitherPal(Picbuf1.Ctl,BackGround.MasterPalette.Ctl);{Map Child to Background}
end;
except
  begin
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;
end;


{Copy Active Child To Palette Buffer}
procedure TTOOLS.Imagetopalette_toolClick(Sender: TObject);
begin
try
if Application.Mainform.MDIChildCount = 0 then Exit;{Non VAlid Image}
With Application.Mainform.ActiveMDIchild as Tdisplay do{Refer to Active Image}
begin
If Picbuf1.Contents <> 1 then Exit;{Non Valid}
If PicBuf1.Colordepth > 8 then {Non VAlid - Warn User}
Begin
MessageDlg('Active Child Does Not have a Palette.' , mtInformation,
[mbOk], 0);
exit;{Abort}
end;
ikAssign(Background.Masterpalette.Ctl,0,Picbuf1.Ctl,0);{Do Transfer}
end;
except
begin
MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
[mbOk], 0);
end;
end;
end;
end.
