{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full  application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}

unit Udisplay;

{This Form is the Main Child Display. It is called DISPLAY and can be refered to as TDISPLAY.
This form is NOT AUTOMATICALLY CREATED - remove it from this list - Project Options. Whenever
we load an Image or Create one we Create a COPY of this. Anything placed here at Design time
is Duplicated in Every Copy of It.  The Chids Menu is Placed on this form and is automatically
merged with the MasterForms menu at Run Time. Remember to set form Style to fschild. Apart
from additional Menu Options the Main events occur in the Mouse Move event of the Child.

In Conjunction with MasterForm the Display form forms the Basis fo the MDI Application. The
Display Form Holds Just one Control PICBUF1.  When we Refer to any child Display we refer
to this PICBUF1.}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, VBXCtrl, ExtCtrls, StdCtrls, Menus,
  Buttons, Ikdsp16, ikCon16, Clipbrd;

type
  TDISPLAY = class(TForm){THIS is the BASE CLASS TDISPLAY - if we refer to it all Controls are avialable}
    MainMenu1: TMainMenu;
    Display1: TMenuItem;
    DynamicZoom1: TMenuItem;
    N4: TMenuItem;
    N2001: TMenuItem;
    N1501: TMenuItem;
    N111: TMenuItem;
    N501: TMenuItem;
    N251: TMenuItem;
    Tune1: TMenuItem;
    ReduceColour1: TMenuItem;
    ColourDepth1: TMenuItem;
    Convertto24Bit1: TMenuItem;
    Convertto8Bit1: TMenuItem;
    Convertto4Bit1: TMenuItem;
    N5: TMenuItem;
    GrayScale1: TMenuItem;
    N6: TMenuItem;
    rgB1: TMenuItem;
    rGb2: TMenuItem;
    Rgb3: TMenuItem;
    N7: TMenuItem;
    Gamma1: TMenuItem;
    Contrast1: TMenuItem;
    Brightness1: TMenuItem;
    Effect1: TMenuItem;
    ExtractEdges1: TMenuItem;
    Mirror1: TMenuItem;
    Vertical1: TMenuItem;
    Horizontal1: TMenuItem;
    Rotate1: TMenuItem;
    UserAngle1: TMenuItem;
    N451: TMenuItem;
    N901: TMenuItem;
    N1801: TMenuItem;
    N902: TMenuItem;
    Matrix551: TMenuItem;
    Matrix331: TMenuItem;
    Blur1: TMenuItem;
    Soften1: TMenuItem;
    Sharpen1: TMenuItem;
    Compute1: TMenuItem;
    Mask1: TMenuItem;
    N8: TMenuItem;
    Merge1: TMenuItem;
    N9: TMenuItem;
    Resize1: TMenuItem;
    N10: TMenuItem;
    Palette1: TMenuItem;
    rgBChannel1: TMenuItem;
    rGbChannel2: TMenuItem;
    RgbChannel3: TMenuItem;
    Histogram1: TMenuItem;
    Paint1: TMenuItem;
    NewImage1: TMenuItem;
    N11: TMenuItem;
    PasteFrom1: TMenuItem;
    CopyTo1: TMenuItem;
    N12: TMenuItem;
    ColorReplace1: TMenuItem;
    Clone1: TMenuItem;
    TouchUp1: TMenuItem;
    Selection1: TMenuItem;
    RemoveArea1: TMenuItem;
    MergeTOArea1: TMenuItem;
    DefineArea1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    PicBuf1: TPicBuf;
    CopytoClipboard1: TMenuItem;
    CopySelectiontoClipboard1: TMenuItem;
    PastefromClipboard1: TMenuItem;
    PastetoSelectionArea1: TMenuItem;
    N3: TMenuItem;
    Popupoptions: TPopupMenu;
    ForcetoTotalRplacement1: TMenuItem;
    ForcetoUnionComposite1: TMenuItem;
    ForcetoIntersectionComposite1: TMenuItem;
    ForcetoResizeComposite1: TMenuItem;
    N13: TMenuItem;
    ForcetoDeletionReplication1: TMenuItem;
    ForcetoDeletionReplicationNotfixed1: TMenuItem;
    ForcetoResamplefixedAspect1: TMenuItem;
    ForcetoResampleNotfixed1: TMenuItem;
    N14: TMenuItem;
    MakeSource1: TMenuItem;
    MakeMask1: TMenuItem;
    MakeDestinationImage1: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    AssigntoRedChannel1: TMenuItem;
    AssigntoGreenChannel1: TMenuItem;
    AssigntoBlueChannel1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PicBuf1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PicBuf1Change(Sender: TObject);
    procedure CopytoClipboard1Click(Sender: TObject);
    procedure PastefromClipboard1Click(Sender: TObject);
    procedure CopySelectiontoClipboard1Click(Sender: TObject);
    procedure PastetoSelectionArea1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PicBuf1Click(Sender: TObject);
    procedure PicBuf1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PicBuf1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ForcetoTotalRplacement1Click(Sender: TObject);
    procedure ForcetoUnionComposite1Click(Sender: TObject);
    procedure ForcetoIntersectionComposite1Click(Sender: TObject);
    procedure ForcetoResizeComposite1Click(Sender: TObject);
    procedure ForcetoDeletionReplication1Click(Sender: TObject);
    procedure ForcetoDeletionReplicationNotfixed1Click(Sender: TObject);
    procedure ForcetoResamplefixedAspect1Click(Sender: TObject);
    procedure ForcetoResampleNotfixed1Click(Sender: TObject);
    procedure AssigntoRedChannel1Click(Sender: TObject);
    procedure AssigntoGreenChannel1Click(Sender: TObject);
    procedure AssigntoBlueChannel1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
   
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  { Refer to Child Display Base Class}
var
DISPLAY: TDISPLAY;{Create the Form DISPLAY based on Design Base form TDisplay}
{Device Context for rubber bands etc - Available to Chdisp only}
var
MyHDC:THandle;{Device Context for rubber bands etc - Available to DISPLAY only}

implementation

{Refer to all Required forms}
Uses UMaster,Ulaunch,UGlobvar,Upref,Uzoom,UBackgnd,Uclone,Ufunct;
{$R *.DFM}

{Set Display Form Close Parameters - allow to fully close. For an MDI child if this
line is Not included then a Child form can only be 'Iconised' not Closed}
procedure TDISPLAY.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action := caFree; {Allow  Child form to be fully closed}
end;

{Resize Picbuf to Form size on user resize action. Since the Child form Display has
a sizinf form style, enlarge the Picbuf Image to suit Client Area - Depending on
Buffers properties the Image is Sized as well}
procedure TDISPLAY.FormResize(Sender: TObject);
begin
try {Set up Error Trap}
with Sender do {Refer to Display Form and 'Size Picbuf1' as required}
  begin
   Picbuf1.Width := ClientWidth;
   Picbuf1.Height := ClientHeight;
  end;
 except{Note:-[Still to Trap]- Known Demo Error - to small a Display will cause a Fatal Error}
 on E: EVBXError do {Catch any VBX Errors}
   MessageDlg('Graphics Function Error - Error Code :'
   + E.Message, mtInformation,
   [mbOk], 0);
 on E: EDivbyZero do {Know error occurs if user sets form size to Zero with Mouse}
    MessageDlg('Image To Small. Either Minimise to Icon or Increase size. - Error Code :'
   + E.Message, mtInformation,
   [mbOk], 0);
       else
        MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
       [mbOk], 0);
   end;
end;

{Set Picbuf to Form Size and other Defaults on Form creation. Whenever a Copy is Made of the
Form at Design time we set up the Picbuf1's options according to the Values stored in the
'Preference' Screen. A lot of functions behaviour alters with differing settings}
procedure TDISPLAY.FormCreate(Sender: TObject);
 begin
  try
  Picbuf1.Width := ClientWidth; {First Load Size Buffer to Displays Client Area}
  Picbuf1.Height := ClientHeight;
{Set Picbuf1.Selection To Default to fullpicture - Stops Selection Errors. Give the Selection
Properties some default Values - Full Screen}
  Picbuf1.SelectTop :=0;
  Picbuf1.SelectLeft :=0;
  Picbuf1.SelectWidth :=Picbuf1.Width;
  Picbuf1.SelectHeight :=Picbuf1.Height;
{Set Default Cursor to my 'Cross hair'}
{1 = 'Normal Cross Hair' this was loaded under Masterform Create Method}
Picbuf1.Cursor := 1;
except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Keep Track of Mouse down locations used In zoom/selection mouse move subs. Whenever the User
Clicks the Mouse on the Image Store the X/Y location of that point in Global MousedownX and
MousedownY. Used in Mouse Move Events etc}
procedure TDISPLAY.PicBuf1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 with Sender do {Refer to Self}
  begin
   try {Set Up Error-Trap}
{Set Globals to store Mouse Location in Pixels X/Y}
    Mousedownx := X;
    Mousedowny := Y;
{Do we require a DContext for Graphics? - Mouseoption of S means yes
ie - Draw Selection Box. Mouse Option is Set unset with Tool Bar Clicks etc. When the User
wants a Selection Area the MouseOption Global Flad is set to 'S'. At present we must
create a Device Context that can be Used with API calls to Draw the Bounding Rectangle. Therefore
Check MouseOption and if it is 'S' Create a DC. Note a further Condition Must be Met - the
user Must be Holding the LeftMouse Button - this stop a RighClick Creating a Phanton DC. The
DC is Created at the Time of the Mouse Left Button being Pressed at the Srat of the Selection
Area being defined by the User - Note the MouseUP Sub below - when the User releases the
left Button the DC created here is Destroyed - we Must do this. Call the DC 'MyHDC'}
    If Mouseoption = 'S' then{Selection Area enabled}
    begin
    If Button = mbLeft then  {Left Button only can be used}
    MyHDC := GetDC(Picbuf1.Handle);{Get a Device Context USE API call NOT Picbuf.HDC}
    end;
{Popup Menu for a right click - check no other function is selected
- sizeing or Dynamic Zoom etc etc Right Button only. A Number of Function can be set for the
Active Image with a Popup Menu. The Popup menu is activated with the Right Mouse Button -
ONLY if no other MouseOptions Have been Selected. This stops the Menu Popping up during
selection, Zoom etc}
If Mouseoption <> 'Q' then Exit;{If any MouseOption is active do not popup}
If Button = mbRight then {Right Button Only For Popup}
Popupoptions.Popup(X,Y); {Pop Up at Mouse Location X,Y}
except
 on E: EVBXError do
     MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
     + E.Message, mtInformation,
     [mbOk], 0);
     else
     MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
   end;
  end;
end;


{Show Mouse Location In Window and Update Statistics. The Mouse Move Event is the Most
important event in the Child DISPLAY. At all times the MOuse Move Event Updates the
Caption Bar inn the MainScreen to Indicate the Mouse Location. MouseOption as
described earlier Holds a Number of Flags that determines which part of the Sub to Execute.
As the User Selects a Function, MouseOption is Updated, and the Sub is Executed accordingly
Using a 'Case MouseOption of' option.}
procedure TDISPLAY.PicBuf1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
Var
Left,Top:Integer; { Temp Variables for Zoom Start Location }
begin
with Sender do   {Make sure Correct child is calling function}
 begin
  try
{If Buffer is empty Abort. Stops Errors for Blank forms if they are created incorrectly
or have no Image Within them.}
If Picbuf1.Contents <> 1  then Exit;
{Mouse Location In Pixels Display in Caption Bar of Masterform - must Convert to Correct format}
Masterform.Mouse.Caption := 'X: ' + Inttostr(IKScreenToImageX(Picbuf1.ctl,X)) +
' Y:' + Inttostr(IKScreenToImageY(Picbuf1.ctl,Y));
{Check which Drawing Tool is Enabled - All toggled from Tool Palette - MouseOption}

Case Mouseoption of {Mouseoption set to required tool eg Z = Dynamic Zoom}

{*************************************** Dynamic ZOOM ************************************}
{Dynamic Zoom Uses the Values Selected in the Preference Screen to Define the Selection area
of the Picbuf1 [Always Active Display - since this code IS EVERY DISPLAY]. This Selection
Area is then Transfered to the Full Picture Area of the ZOOM Display - ZOOM.PICBUF1. The Image
is shifted so the Cursor Appears to the User 'Central' to the Selection AREA. Ie the Mouse
Pointer is Over the Middle of the Image Showing in the ZOOM window}
'Z':{Dynamic Zoom Enabled - Use 'Begin End' Block}
begin
 Picbuf1.Cursor:= 2; {Set Dynamic Zoom Cursor}
  If ssLeft in Shift then {User Must Hold Right Mouse Button}
   begin
   {Do a Calculation so Cursor Appears in the MIDDLE of the Selection AREA - Shift AREA}
    Left := IKScreenToImageX(Picbuf1.ctl,X);{Work Out Left Location - in Image Pixels}
    Top :=  IKScreenToImageY(Picbuf1.ctl,Y);{Work out Top Location - in Image Pixels}
    Picbuf1.Selectleft:= Left - (StrtoInt(Preferences.Zoomwidth.Caption) DIV 2); {Shift Area}
    Picbuf1.Selecttop := Top - (StrtoInt(Preferences.Zoomheight.Caption) DIV 2); {Shift Area}
    Picbuf1.SelectHeight := StrtoInt(Preferences.Zoomheight.Caption);{Set Height}
    Picbuf1.SelectWidth := StrtoInt(Preferences.Zoomwidth.Caption);{Set Width}
    Ikassign(Zoom.Picbuf1.Ctl,0,Picbuf1.Ctl,-1);{Do the Zoom [Zoom.Picbuf1 is Zoom Window form]}
  end;
end;

{******************************** Selection Area Size ***********************************}
{Mouseoption set to 'S' or section function - We Refer to the Device Context Created in the
Mouse Down Event. We Use Delphi API calls to Draw the Rubber BAnd. Note:- Win95 User
might find the Band only Drawn for area defined by the User who starts at the upper left
of the area and Drags the Mouse to the Lower Right. New Users should always Reverse
the AreaSelection properties to Account for this - see Mouse up code an example is given
which does this to make sure the Selection Area is always correct for the Buffer.AreaSelection
is a Global Trect Structure see Uglobvar}

'S':{Selection Area Enabled 'Mousedownx' and 'Mousedowny' globals used}
Begin{Loop for text selection area}
 Picbuf1.Cursor:= 3;{Enable Select Cursor}
{User Must Hold Right Mouse Button - Shift is Always passed by Delphi - If executes when the
If ssleft IN shift return a True Value - a number of keys can be tested for}
  If ssLeft in Shift then {If True Execute Sub - Only True when the user is HOLDING the button}
   begin{Button hold loop sizing area}
   {Area Selection is a Trect Structure refer to Mouse down Call for start location}
    Drawfocusrect(MyHDC,Areaselection);{Start Selection Box - DrawFocusRect is a Delphi call}
    Areaselection.Top := Mousedowny; {Use Global MouseDown}
    Areaselection.Left := Mousedownx;{Use Global MouseDown}
    Areaselection.Right := X;{Use Current Mouse LOcation passed by Delphi}
    Areaselection.Bottom := Y;{Use Current Mouse LOcation passed by Delphi}
    Drawfocusrect(MyHDC,Areaselection);{Erase Selection Box}
    {Calculate width and height of selected area - ie last known size after mouse move - store}
    Areaselectionwidth := AreaSelection.Right - AreaSelection.Left;
    Areaselectionheight := AreaSelection.Bottom - AreaSelection.Top;
    end;{End Button Hold Loop sizing area}
end;{End Loop from first Begin for text}

{****************************************     Clone          ***********************}
{The Clone Function is Similar to Dynamic Zoom but Instead of using a Zoom window
the Area is copied into another Image - Note Assign Modes do effect how this Function Behaves.
The CLONE DISPLAY HOLDS the SOURCE IMAGE the DESTINATION image is the ACTIVE CHILD - again
in effect THIS Picbuf1}

{'MouseOption' set to 'C'. Within this CASE Branch based on MouseOption we used a Nested Case
which lets the User select between two Clone Types - CloneOption.ItemIndex is the Group
of Radio Button on the Clone Form. }
'C':
Begin {Start Clone Sub - Refers to Clone Picbuf}
 Picbuf1.Cursor:= 5;{Enable Clone Cursor}
  If ssLeft in Shift then {User Must Hold Right Mouse Button to clone}
    begin {Start left hold button loop -clone loop-}
    {Check that Clone Source and Destination are of the SAME bitdepths}
     If Picbuf1.Colordepth <> Clone.Picbuf1.Colordepth then
      begin
       MessageDlg('Source Image and Destination Image must have the same Color Depth.'+
       'Choose OK to Continue.' , mtInformation,[mbOk], 0);
       Exit;{Abort for None Valid Images}
       end;
        case Clone.Cloneoptions.Itemindex of {What Clone function is Selected}
        0: begin{1:1 Mapping Source and Dest Images areas Identical}
        Left := IKScreenToImageX(Picbuf1.ctl,X);{Get Start Location}
        Top :=  IKScreenToImageY(Picbuf1.ctl,Y);{Get Start Location}
        {Shift Mouse location so cursor appears central in selection Area - Work out Area - as above}
        {Define Selection Area - size is set by Clone Width/Height Controls}
        Picbuf1.Selectleft:= Left - (StrtoInt(Clone.Clonewidth.Caption) DIV 2);
        Picbuf1.Selecttop := Top - (StrtoInt(Clone.Cloneheight.Caption) DIV 2);
        Picbuf1.SelectHeight := StrtoInt(Clone.Cloneheight.Caption);
        Picbuf1.SelectWidth := StrtoInt(Clone.Clonewidth.Caption);
        {Apply SAME AREA  to Source Image which is the 'Clone Forms' Preview Image}
        Clone.Picbuf1.Selectleft:= Left - (StrtoInt(Clone.Clonewidth.Caption) DIV 2);
        Clone.Picbuf1.Selecttop := Top - (StrtoInt(Clone.Cloneheight.Caption) DIV 2);
        Clone.Picbuf1.SelectHeight := StrtoInt(Clone.Cloneheight.Caption);
        Clone.Picbuf1.SelectWidth := StrtoInt(Clone.Clonewidth.Caption);
        {Copy Source Image To Dest Image - Selection to Selection}
        Ikassign(Picbuf1.Ctl,-1,Clone.Picbuf1.Ctl,-1);{Do the Zoom [Zoom.Picbuf1 is Zoom Window form]}
      end;{0 loop or 1:1 Mapping}
 {The Next Selction is the Same as above for the Active Child Displays Area but the Clone
 Source Area is Defined with the Mouse By the User. The Child Display Area is still set
 with the Clone Height and Width options}
     1: begin{Fixed Source clone location - start - Clone area set by 'mouse Drag Operation'}
        Left := IKScreenToImageX(Picbuf1.ctl,X);{Get Start Location}
        Top :=  IKScreenToImageY(Picbuf1.ctl,Y);
        {Shift Mouse location so cursor appears central
        in selection Area - Work out Area}
        Picbuf1.Selectleft:= Left - (StrtoInt(Clone.Clonewidth.Caption) DIV 2);
        Picbuf1.Selecttop := Top - (StrtoInt(Clone.Cloneheight.Caption) DIV 2);
        Picbuf1.SelectHeight := StrtoInt(Clone.Cloneheight.Caption);
        Picbuf1.SelectWidth := StrtoInt(Clone.Clonewidth.Caption);
        {'Clone Selection' Area was already set BY THE user with the Mouse}
        Ikassign(Picbuf1.Ctl,-1,Clone.Picbuf1.Ctl,-1);{Do the Zoom [Zoom.Picbuf1 is Zoom Window form]}
        end; {End Clone fixed Source Loop}
     end;{End Clone Loop}
  end; {End user must hold left button loop -clone loop-}
end;  {End Over All Must Hold Loop}
{************************************ Reset Tools etc on 'Q' *************************}
else {Reset Values Cursors etc on any other than defined tool either Q or anything}
Picbuf1.Cursor :=1; {Normal Pick Cursor}
end;{End Over All CASE LOOP}
{Error Trap}
except
  on E: EVBXError do
   MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
   + E.Message, mtInformation,
   [mbOk], 0);
       else
        MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
       [mbOk], 0);
   end;
  end;
end;

{Set Selection Area If Mouse Option was for Select area or 'S' function. Finsih Drawing selection
Area- Erase it. Kill the DC if One had Been Created  and Set Picbuf Area to Selection
are if Required. Note that you must Make sure you swap the selection area values around
depending on which Direction the Area Was Selected - This is so Left/Right Top/Bottom are
always Positive and Correctly Defined.}
procedure TDISPLAY.PicBuf1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var
Temp:Integer;
begin
  with Sender do {Refer to Self}
   try
    If Button = mbRight then Exit;{Only Perform below on left button up - Right Clicks
    only Show Popups}
{What Function was being executed ?}
    Case Mouseoption of
    'S':{Was a Selection area being requested if Yes Erase it and KILL the DC}
     begin
     Drawfocusrect(MyHDC,Areaselection);{Erase Last Area}
     ReleaseDC(Picbuf1.Handle,MyHDC);{Destroy Device context}
{Check to see 'Mouse Drag Direction' and alter accordingly - First Check if 'Bottom Value' is
less than 'Top Value' make Top and Bottom Swap Values- This occurs if the mouse was
dragged from the 'bottom' of an Image up the way NOTE:-
Nothing required for a Left to Right / Top to Bottom Drag}
If AreaSelection.Top  > AreaSelection.Bottom then
 Begin
  Temp := AreaSelection.top; {Temp Storage}
  AreaSelection.Top := AreaSelection.Bottom; {Swap}
  AreaSelection.Bottom := Temp;{Swap}
 end;
 {Check Left and Right Swap if Left Value > Right Value.This occurs if the Mouse was Dragged
 Right to Left}
If AreaSelection.Left > AreaSelection.Right then
 Begin
  Temp := AreaSelection.Left;
  AreaSelection.Left := AreaSelection.Right;  {Swap}
  AreaSelection.Right := Temp; {Swap}
 End;
 {Calculate Width and Height of Area in Pixels}
     Selectionwidth := AreaSelection.Right - AreaSelection.Left;
     Selectionheight := AreaSelection.Bottom - AreaSelection.Top;
 {Assign Values to Picbuf Control - Convert to Image Realative Pixels for Zoomed Images}
     Buffertop:= IkScreentoImageY(Picbuf1.Ctl,AreaSelection.Top);
     Bufferleft:= IkScreentoImageX(Picbuf1.Ctl,AreaSelection.Left);
     Bufferheight:= IkScreentoImageY(Picbuf1.Ctl,Selectionheight);
     Bufferwidth:= IkScreentoImageX(Picbuf1.Ctl,SelectionWidth);
 {Check No Negative Values - Multiply by -1 is there is}
    If Buffertop < 0 then Buffertop:= Buffertop * -1;
    If Bufferleft < 0 then Bufferleft:= Bufferleft * -1;
    If Bufferheight < 0 then Bufferheight:= Bufferheight * -1;
    If Bufferwidth < 0 then Bufferwidth:= Bufferwidth * -1;
 {Set Selection Area after all Checks. No Correctly Set regardless of Mouse Direction During
 the Selection Phase}
    Picbuf1.Selecttop := Buffertop;
    Picbuf1.SelectLeft := Bufferleft;
    Picbuf1.SelectHeight := Bufferheight;
    Picbuf1.SelectWidth := Bufferwidth;
 {Reset Area Selection by Default}
  AreaSelection.Top := 0;{Reset Area Rect to 0,0}
  AreaSelection.Left := 0;
  AreaSelection.Right:=0;
  AreaSelection.Bottom:=0;
 {Reset Mouseoption and Cursor to Defaults - Kill Select Function On Mouse Up}
  Mouseoption:='Q';
  Picbuf1.Cursor:=1; {Normal Cursor}
 end;{End of Select Case sub}
end;
except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Update Picture Statistics Display as the contents Change. This enables the User
to see the Result of Certain Functions}
procedure TDISPLAY.PicBuf1Change(Sender: TObject);
begin
 try
  If Picbuf1.Contents <> 1 then Exit;{If Buffer is empty abort}
  Masterform.Properties.Caption := '[ ' + InttoStr(Picbuf1.Xresolution) + ' - ' +
  InttoStr(Picbuf1.Yresolution) + ' ] ' + '[ ' + InttoStr(Picbuf1.Colordepth) +' ]'+ ' [ '+
  InttoStr((IkGetColorCount(Picbuf1.Ctl))) + ' ]';
 except
  on E: EVBXError do
   MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
   + E.Message, mtInformation,
   [mbOk], 0);
  else
   MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;



{Do Copy Paste functions - Refer to Utool Unit for an explanation - this is a copy - New
users should avoid this duplication of Code}
procedure TDISPLAY.CopytoClipboard1Click(Sender: TObject);
begin
   try
    If Picbuf1.Contents <> 1 then Exit;
    Picbuf1.CopyDib := True;{Full Picture Area}
   except
    on E: EVBXError do
    MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
    + E.Message, mtInformation,
     [mbOk], 0);
      else
      MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
     end;
end;

{Paste to Full Image - Refer to Utool Unit for an explanation - this is a copy - New
users should avoid this duplication of Code}
procedure TDISPLAY.PastefromClipboard1Click(Sender: TObject);
begin
 with Sender do
  begin
   try
    If Picbuf1.Contents <> 1 then Exit;
    Picbuf1.PasteDib := True;
   except
    on E: EVBXError do
    MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
    + E.Message, mtInformation,
     [mbOk], 0);
     else
     MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
     end;
  end;
end;

{Copy Selection - Refer to Utool Unit for an explanation - this is a copy - New
users should avoid this duplication of Code}
procedure TDISPLAY.CopySelectiontoClipboard1Click(Sender: TObject);
begin
 with Sender do
  begin
   try
    If Picbuf1.Contents <> 1 then Exit;
    Picbuf1.CopySelection := True;
    except
    on E: EVBXError do
    MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
    + E.Message, mtInformation,
    [mbOk], 0);
    else
    MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
    end;
  end;
end;

{Paste Selection - Refer to Utool Unit for an explanation - this is a copy - New
users should avoid this duplication of Code}
procedure TDISPLAY.PastetoSelectionArea1Click(Sender: TObject);
begin
 with Sender do
  begin
   try
    If Picbuf1.Contents <> 1 then Exit;
    Picbuf1.PasteSelection := True;
   except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
 end;
end;

{Size form to Requested default set by preference form. Whenever this form is Loaded at Runtime
set the Size of by Checking the Values Set in the Preference Screen}
procedure TDISPLAY.FormShow(Sender: TObject);
begin
try
With Sender do
 Begin
  ClientWidth:= StrtoInt(Preferences.DefaultWidth.Caption);
  ClientHeight:= StrtoInt(Preferences.DefaultHeight.Caption);
 end;
 except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;


{Update Statistics on Click to Picture Area + Palette. For 8 Bit Graphics Card users
make the Palette of THIS image the Current Palette.}
procedure TDISPLAY.PicBuf1Click(Sender: TObject);
begin
 try
  If Picbuf1.Contents <> 1 then Exit;{If Buffer is empty abort}
   Masterform.Properties.Caption := '[ ' + InttoStr(Picbuf1.Xresolution) + ' - ' +
   InttoStr(Picbuf1.Yresolution) + ' ] ' + '[ ' + InttoStr(Picbuf1.Colordepth) +' ]'+ ' [ '+
   InttoStr((IkGetColorCount(Picbuf1.Ctl))) + ' ]';
   {Update Image Palette for 8 Bit Image}
   If Picbuf1.Colordepth > 8 then Exit;{No Palette}
   IksetScreenpal(Picbuf1.ctl);
  except
   on E: EVBXError do
   MessageDlg('Graphics Function Error - Source and Destination Images incompatible - Error Code :'
   + E.Message, mtInformation,
   [mbOk], 0);
   else
   MessageDlg('A System Error has occured. Choose OK to Continue.' , mtInformation,
     [mbOk], 0);
  end;
end;


{Set AssignModes/Resize Modes for active Display with a Popup menu - these menu
Item are set with a RightClick over the image If no MouseOption is set.
Unlike the Preference Screen they Effect the Active Child}
procedure TDISPLAY.ForcetoTotalRplacement1Click(Sender: TObject);
begin
Picbuf1.Assignmode := 0;
end;
{Set AssignModes/Resize Modes for active Display with a Popup menu}
procedure TDISPLAY.ForcetoUnionComposite1Click(Sender: TObject);
begin
Picbuf1.Assignmode := 1;
end;
{Set AssignModes/Resize Modes for active Display with a Popup menu}
procedure TDISPLAY.ForcetoIntersectionComposite1Click(Sender: TObject);
begin
Picbuf1.Assignmode := 2;
end;
{Set AssignModes/Resize Modes for active Display with a Popup menu}
procedure TDISPLAY.ForcetoResizeComposite1Click(Sender: TObject);
begin
Picbuf1.Assignmode := 3;
end;
{Set AssignModes/Resize Modes for active Display with a Popup menu}
procedure TDISPLAY.ForcetoDeletionReplication1Click(Sender: TObject);
begin
Picbuf1.Resizemode := 0;
end;
{Set AssignModes/Resize Modes for active Display with a Popup menu}
procedure TDISPLAY.ForcetoDeletionReplicationNotfixed1Click(
  Sender: TObject);
begin
Picbuf1.Resizemode := 1;
end;
{Set AssignModes/Resize Modes for active Display with a Popup menu}
procedure TDISPLAY.ForcetoResamplefixedAspect1Click(Sender: TObject);
begin
Picbuf1.Resizemode := 2;
end;
{Set AssignModes/Resize Modes for active Display with a Popup menu}
procedure TDISPLAY.ForcetoResampleNotfixed1Click(Sender: TObject);
begin
Picbuf1.Resizemode := 3;
end;

{Transfer/Copy Display to Background Buffer - Red. This allows the Image to be
copied to the Background Form Red Buffer for the Merge Function - New Users
should Check for 24 Bit Images}
procedure TDISPLAY.AssigntoRedChannel1Click(Sender: TObject);
begin
try
ikAssign(Background.RedBuffer.ctl,0,Picbuf1.ctl,0);
except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Transfer/Copy Display to Background Buffer - Green This allows the Image to be
copied to the Background Form Green Buffer for the Merge Function - New Users
should Check for 24 Bit Images}
procedure TDISPLAY.AssigntoGreenChannel1Click(Sender: TObject);
begin
try
ikAssign(Background.GreenBuffer.ctl,0,Picbuf1.ctl,0);
except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Transfer/Copy Display to Background Buffer - Blue This allows the Image to be
copied to the Background Form Blue Buffer for the Merge Function - New Users
should Check for 24 Bit Images}
procedure TDISPLAY.AssigntoBlueChannel1Click(Sender: TObject);
begin
try
ikAssign(Background.BlueBuffer.ctl,0,Picbuf1.ctl,0);
except
  on E: EVBXError do
  MessageDlg('Graphics Function Error - Error Code :'
  + E.Message, mtInformation,
  [mbOk], 0);
  else
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;


{Double check user wants to close Display - set Flags. Let the User Confirm
Display closure when the Form is Closed with a Normal Exit Option - 'Halting' the
program Skips this Check - Note the Normalise Form Calls - this Makes sure
a Dialog box is allowed to be the Topmost Form}
procedure TDISPLAY.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  ButtonSelected: Word;
begin
  Application.NormalizeTopMosts;{Let 'Dialog Box' be 'OnTop' of All Forms}
  ButtonSelected := MessageDlg('Please confirm you wish to close Display:- ' + Caption, mtInformation,
    [mbyes, mbNo], 0);
  if ButtonSelected = mryes then
    CanClose := True
  else
  begin
      CanClose := False;
  end;
   Application.RestoreTopMosts;{Restore Top MOst froms if User does not Quit}
end;


end.
