{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full  application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}

{This Unit Holds Standard functions - Final Versions all Functions will reside here}
{Used for Standard Imageknife Functions. It would be Normal Practice to Put functions
in common Units. The User Can then Re-Use the Units in Other Projects.}

unit Ufunct;

interface
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, VBXCtrl, ExtCtrls, StdCtrls, Menus,
  Buttons, Ikdsp16, ikCon16, Clipbrd;

{By Declaring the Function here in the 'Interface' section we make them available to all
functions that refer to this Unit}

{Sharpen an image}
Procedure Sharpen;
{Soften Image}
Procedure Soften;
{Edge Extract}
Procedure Edgeextract;
{Rotate Image}
Procedure Rotate;
{Blur Image}
Procedure Blur;

implementation

Uses Udisplay,Uamount,Uglobvar;{Refer to other Units, Remember always to refer to
the Knife Files whenever you are going to be calling a Fuction - Uses Unit above}

{Lets Sharpen the Image - All simillar functions call the amount Box to set the value}
Procedure Sharpen;
begin
try
Amount.Showmodal; {Show Amount form if 'OK' selected execute function}
If Amount.Modalresult = mrOK then {Execute on 'OK' button only}
begin
With Application.Mainform.ActiveMDIchild as TDisplay do
begin
Screen.Cursor := 4; {Wait Cursor}
IKsharpen(Picbuf1.Ctl,Amountset);{Apply Using Global Amountset - Amountset is set from the
'Amount' Form unit Uamount}
Screen.Cursor := crdefault; {Normal Cursor}
end;
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Soften Image - as above}
Procedure Soften;
begin
try
Amount.Showmodal; {Show Amount form if 'OK' selected execute function}
If Amount.Modalresult = mrOK then {Execute on OK only}
begin
With Application.Mainform.ActiveMDIchild as TDisplay do
begin
Screen.Cursor := 4; {Wait Cursor}
IKSoften(Picbuf1.Ctl,Amountset);
Screen.Cursor := crdefault; {Normal Cursor}
end;
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Extract Edges - as above}
Procedure Edgeextract;
begin
try
Amount.Showmodal; {Show Amount form if 'OK' selected execute function}
If Amount.Modalresult = mrOK then {Execute on OK only}
begin
With Application.Mainform.ActiveMDIchild as TDisplay do
begin
Screen.Cursor := 4; {Wait Cursor}
IKExtractedges(Picbuf1.Ctl,Amountset);
Screen.Cursor := crdefault; {Normal Cursor}
end;
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Roatation angle used to Rotate Image - as above}
Procedure Rotate;
begin
try
Amount.Showmodal; {Show Amount form if 'OK' selected execute function}
If Amount.Modalresult = mrOK then {Execute on OK only}
begin
With Application.Mainform.ActiveMDIchild as TDisplay do
begin
Screen.Cursor := 4; {Wait Cursor}
IKRotate(Picbuf1.Ctl,Rotationangle,RGB(0,0,0));{Use Black to fill surrounds}
Screen.Cursor := crdefault; {Normal Cursor}
end;
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Blur Image - as above}
Procedure Blur;
begin
try
With Application.Mainform.ActiveMDIchild as TDisplay do
begin
Screen.Cursor := 4; {Wait Cursor}
IKBlur(Picbuf1.Ctl);
Screen.Cursor := crdefault; {Normal Cursor}
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

end.
