{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full  application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.
ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}

{Uglobvar Holds all Global Variables}
unit Uglobvar;

interface {Interface Section for Globals}

Uses WinTypes;

         var
         Filespec: Pchar;{Holds FileSpec for loading Images}
         Jpgquality: Integer;{Holds Jpeg Quality for program}
         Lastfilter: Integer;{Holds Last Opened/Saved extension}
         Channeldisplay: String;{N/A}
         Dynamiczoom: Boolean;{Dynamic Zoom enable/Disable}
         Mouseoption: Char;{What mouse operation? - Select / Clone Etc}
         Zoomheight: Integer;{Zoom height for Dynamic Zoom}
         Zoomwidth: Integer;{Zoom width for Dynamic Zoom}
         Mousedownx: Integer; {Keep Track of Mouse down event X location}
         Mousedowny: Integer;{Keep Track of Mouse down event Y location}
         Areaselection: TRect;{Set up Rectangle to hold Text Area - for Drawing area}
         Areaselectionwidth :Integer;{Keep track of selected area Width}
         Areaselectionheight : Integer;{Keep Track of Selected Height}
         {Used in Selection Area Process}
         SelectionHeight,SelectionWidth,Buffertop,Bufferleft,Bufferwidth,Bufferheight:Integer;
         Amountset:Integer; { Holds last requested amount for Sharpen/Soften/Blur}
         Rotationangle: Integer;
         Type {Used in GetScanline functions}
         Scanarray = ^Scandataarray;
         Scandataarray = array[0..1800] of Longint;{Hods 1800 elements Max}
         Type {Used in Getpalette functions}
         Palarray = ^Paldataarray;
         Paldataarray = array[0..255] of Longint;
         Var
         Paldata: Paldataarray;{Holds Palette values for Palette Display Option}
         var
         Lastbrightvalue: Double;{Brightness contrast routine}
         Lastcontvalue: Double;{As above}
         implementation
{Set Defaults Values to Variables if Required}
initialization
Lastfilter:=1;{Default *.* extension for Dialog Boxes}
Dynamiczoom := False;{use on Dynamic Zomm functions}
MouseOption := 'Q';{Set to no tool as default}
Lastbrightvalue := 0.5;{Default no change}
Lastcontvalue:= 0.5;{Default no change}
Amountset:= 1;{Set 1 as Default for Sharpen/Soften/Blur}
Rotationangle := 90;{Set Default Rotate angle}
end.
 