{Program Written By Andrew Hutchison

Belmont Imaging
22 Easter Belmont Road
Edinburgh
EH12 6EX
Scotland
UK

Tel UK + 44 131 337 8797
Fax UK + 44 131 313 2002
Compuserve 100022,1047

See 'About Box' for Further Details when Running Demo. Registered user Receive Upgrade to
Full Version.

There is an Extra Cost Option of fully annotated code for the Full  application and User Manual.
We hope Users Can use the Code as a Guide to Writing a New Application. It is also
useful for Visual Basic Users in that the Pascal Language used is similar in Structure
with Minor variations in syntax.

User Require to Buy ImageKnife 2.0 in addition from Media Architects if they wish to RUN the
Code within the Delphi DESIGN Environment. Users also Require Borlands Delphi.

ImageKnife Is a Product of Media Architects, 7320 SW Hunzifer Road, Portland, Oregon 97223
USA. Tel 503-639-2505.  ImageKnife may be Registered and Obtained from them.}


unit Utint;

{This Form is the 'TINT' form - Please Refer to the UTune Unit for a full desciption-
both form use the Same Method}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, VBXCtrl, Ikdsp16, Buttons, Gauges,
  Menus;

type
  TTint = class(TForm)
    Rchannel: TScrollBar;
    Gchannel: TScrollBar;
    Bchannel: TScrollBar;
    PicBuf1: TPicBuf;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Realtime: TCheckBox;
    Transfer: TSpeedButton;
    Preview: TSpeedButton;
    Bevel2: TBevel;
    Tint_Popup: TPopupMenu;
    Pintofront: TMenuItem;
    Pintoback: TMenuItem;
    Redvalue: TLabel;
    Greenvalue: TLabel;
    Bluevalue: TLabel;
    Grabtint: TSpeedButton;
    Exittint: TSpeedButton;
    procedure RchannelChange(Sender: TObject);
    procedure GchannelChange(Sender: TObject);
    procedure BchannelChange(Sender: TObject);
    procedure PreviewClick(Sender: TObject);
    procedure TransferClick(Sender: TObject);
    procedure PintofrontClick(Sender: TObject);
    procedure PintobackClick(Sender: TObject);
    procedure GrabtintClick(Sender: TObject);
    procedure ExittintClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Tint: TTint;{Form Name}

implementation

Uses Uglobals,Udisplay,ikcon16;
{$R *.DFM}


{Auto Call to RGBTUNE suB in UGlobals Unit - refer to It - Red Channel - Called}
procedure TTint.RchannelChange(Sender: TObject);
begin
try
Redvalue.Caption := 'Red: ' + InttoStr((Rchannel.Position)*-1);
If Realtime.checked = false then Exit;{No auto update}
Rgbtune('C'); {Call Sub pass 'C' to Indicate tint Channel + update display captions}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Auto Call to RGBTUNE sub in UGlobals Unit - refer to It - Green Channel - Called}
procedure TTint.GchannelChange(Sender: TObject);
begin
try
Greenvalue.Caption := 'Green: ' + InttoStr((Gchannel.Position)*-1);
If Realtime.checked = false then Exit;{No auto update}
Rgbtune('C'); {Call Sub pass 'C' to Indicate Tint Channel }
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Auto Call to RGBTUNE sub in UGlobals Unit - refer to It - Blue Channel - Called}
procedure TTint.BchannelChange(Sender: TObject);
begin
try
Bluevalue.Caption := 'Blue: ' + InttoStr((Bchannel.Position)*-1);
If Realtime.checked = false then Exit;{No auto update}
Rgbtune('C'); {Call Sub pass 'C' to Indicate Tint Channel }
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Call Preview function not automatic - Update Preview Image On Demand}
procedure TTint.PreviewClick(Sender: TObject);
begin
try
Rgbtune('C');{Call Uglobal RGBTUNE sub 'C' parameters for Tint Required}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Transfer Image to Mainscreen from Preview Screen of tint form - this enables us to
overwrite the Child Display with the Tinted Version}
procedure TTint.TransferClick(Sender: TObject);
begin
try
If Application.Mainform.MDIChildcount = 0 then Exit;{Abort if no Child}
If Tint.Picbuf1.Contents <> 1 then Exit; {Check for Valid child}
With Application.Mainform.ActiveMDIchild as TDisplay do{Refer to Active Child}
begin
IkAssign(Picbuf1.Ctl,0,Tint.Picbuf1.Ctl,0);{Do the Transfer}
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Send form to Background ie Not on top}
procedure TTint.PintofrontClick(Sender: TObject);
 begin
  Tint.Formstyle := fsStayonTop;
  Pintofront.Checked:=True;
  Pintoback.Checked:=False;
end;

{Make form always on top bring to front}
procedure TTint.PintobackClick(Sender: TObject);
 begin
  Tint.Formstyle := fsNormal;
  Pintofront.Checked:=False;
  Pintoback.Checked:=True;
  end;

{Grab the Active Child Image and Place in Preview Display - Nor required but is added
for ease of use - Any call to the RGBTUNE sun Loads the Active Child. Warn the user for
non Valid Images}
procedure TTint.GrabtintClick(Sender: TObject);
{Get Image from active Child Display}
begin
try
If Application.Mainform.MDIchildcount = 0 then Exit; {No Child}
With Application.Mainform.ActiveMDIchild as TDisplay do{refer to Child}
begin
If Picbuf1.ColorDepth < 24 then {Image Must Be 24 Bit}
begin
MessageDlg('Image Must Be 24 Bit Convert If Required. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
Exit;
end;
ikassign(Tint.Picbuf1.ctl,0,Picbuf1.ctl,0); {Copy Valid Image Accross}
end;
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Close Tint Form - Clear Buffer - save resources if you kill buffers as you go.}
procedure TTint.ExittintClick(Sender: TObject);
begin
try
Ikclear(Picbuf1.Ctl);{Kill Image}
Tint.Hide;{Hides Form}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Kill Image on close - Kills image if the Form is closed by ANY Method}
procedure TTint.FormClose(Sender: TObject; var Action: TCloseAction);
begin
try
Ikclear(Picbuf1.Ctl);{Kill Image}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

{Kill Image on Hide form by ANY method}
procedure TTint.FormHide(Sender: TObject);
begin
try
Ikclear(Picbuf1.Ctl);{Kill Image}
except
  MessageDlg('A System Error has occured - test. Choose OK to Continue.' , mtInformation,
  [mbOk], 0);
  end;
end;

end.
